SystemOrganization addCategory: #'Finder-Core'!
SystemOrganization addCategory: #'Finder-Tests'!
SystemOrganization addCategory: #'Finder-UI'!

MorphTreeNodeModel subclass: #FinderNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Finder-UI'!

FinderNode subclass: #FinderClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Finder-UI'!

!FinderClassNode methodsFor: 'converting' stamp: 'jb 7/1/2011 10:52'!
asString
	"Each time a classNode is drawn, if i'm looking for
	patterns, I test if my parent is a method, if it is ,I check
	if this method could be an instance the class"
	| prefix |
	prefix := ''.
	self parentNode
		ifNotNil: [:parent | 
			| string receiverString receiver |
			"My parent is a FinderMethodNode"
			string := parent item. 
			self model  finder currentSearchMode == #Examples
				ifTrue: [receiverString := self foundReceiverOf: string.
					receiver := self class evaluatorClass evaluate: receiverString.
					(receiver isKindOf: self item)
						ifTrue: [prefix := '*']]].
	^ self item
		ifNotNil: [:i | prefix , self item name asString]! !

!FinderClassNode methodsFor: 'private' stamp: 'CamilloBruni 2/21/2011 15:58'!
browse
	self hasParentNode ifFalse: [ ^ super browseClass ].
	self browseClass! !

!FinderClassNode methodsFor: 'private' stamp: 'IgorStasenko 3/6/2011 18:52'!
browseClass
	Smalltalk tools browser fullOnClass: self item selector: self parentNode item! !

!FinderClassNode methodsFor: 'private' stamp: 'CamilloBruni 2/21/2011 15:56'!
browseReferences
	SystemNavigation default browseAllCallsOnClass: self item.! !

!FinderClassNode methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 21:03'!
childNodeClassFromItem: anItem 
	"The children (if there are some) are instances of
	FinderMethodNode (in the case of a Classes research)"
	^ FinderMethodNode ! !

!FinderClassNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/15/2010 12:06'!
childrenItems
	"I search the children, if I have not got any, I call my super method"
	^ (self model resultDictionary at: self item ifAbsent:[^super childrenItems])! !

!FinderClassNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/12/2011 17:56'!
foundReceiverOf: aString
	"It's ugly, but I haven't found a method that allows me to do that easily"

	| selector index firstPart |
	selector := (self model finder findSelector: aString).
	index := selector indexOf: $:.
	firstPart := selector.
	(index = 0)
		ifFalse: [firstPart := selector copyFrom: 1 to: index].
	index :=  aString findString: firstPart.
	^ aString copyFrom: 1 to: (index-1).! !

!FinderClassNode methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:46'!
keyStroke: anEvent
	(anEvent controlKeyPressed or: [ anEvent commandKeyPressed ]) ifFalse: [ ^ false ].
	anEvent keyCharacter == $h ifTrue: [ ^ self browseHierarchy ].
	anEvent keyCharacter == $N ifTrue: [ ^ self browseReferences ].
	^ super keyStroke: anEvent.! !

!FinderClassNode methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:53'!
menu: menu shifted: aBoolean
	menu
		add: 'Hierarchy (h)' translated
		target: self
		selector: #browseHierarchy.
	menu
		add: 'References (N)' translated
		target: self
		selector: #browseReferences.
	^ super menu: menu shifted: aBoolean.! !

FinderNode subclass: #FinderMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Finder-UI'!

!FinderMethodNode methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:49'!
addInspectMenuItem: menu

	self hasParentNode ifTrue: [ ^ super addInspectMenuItem: menu ].! !

!FinderMethodNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/3/2011 13:29'!
browse
	self parentNode
		ifNotNil: [:parent | self browseClass].! !

!FinderMethodNode methodsFor: 'private' stamp: 'IgorStasenko 3/6/2011 18:52'!
browseClass
	Smalltalk tools browser fullOnClass: self parentNode item selector: self item! !

!FinderMethodNode methodsFor: 'private' stamp: 'CamilloBruni 2/21/2011 15:43'!
browseImplementors
	SystemNavigation default browseAllImplementorsOf: self item.! !

!FinderMethodNode methodsFor: 'private' stamp: 'CamilloBruni 2/21/2011 15:42'!
browseSenders
	SystemNavigation default browseAllCallsOn: self item.! !

!FinderMethodNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/15/2010 12:13'!
childNodeClassFromItem: anItem
"I answer the class of my children nodes (if I have some)"
	^ FinderClassNode! !

!FinderMethodNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/15/2010 12:13'!
childrenItems
	"I search the children, if I have not got any, I call my super method"
	^ (self model resultDictionary at: self item ifAbsent:[^super childrenItems])! !

!FinderMethodNode methodsFor: 'private' stamp: 'CamilloBruni 2/21/2011 16:12'!
inspectItem
	self hasParentNode ifTrue: [ (self parentNode item methodDict at: self item) inspect ].! !

!FinderMethodNode methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:46'!
keyStroke: anEvent
	(anEvent controlKeyPressed or: [ anEvent commandKeyPressed ]) ifFalse: [ ^ false ].
	anEvent keyCharacter == $n ifTrue: [ ^ self browseSenders ].
	anEvent keyCharacter == $m ifTrue: [ ^ self browseImplementors ].
	^ super keyStroke: anEvent.! !

!FinderMethodNode methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:54'!
menu: menu shifted: aBoolean
	
	menu
		add: 'Implementors (m)' translated
		target: self
		selector: #browseImplementors.
		
	menu
		add: 'Senders (n)' translated
		target: self
		selector: #browseSenders.
		
	^ super menu: menu shifted: aBoolean.! !

!FinderNode methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:53'!
addInspectMenuItem: menu

	menu
		add: 'Inspect (i)' translated
		target: self
		selector: #inspectItem.! !

!FinderNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/3/2011 13:30'!
browse

	self subclassResponsibility! !

!FinderNode methodsFor: 'private' stamp: 'IgorStasenko 3/6/2011 18:52'!
browseClass
	Smalltalk tools browser fullOnClass: self item! !

!FinderNode methodsFor: 'private' stamp: 'CamilloBruni 2/21/2011 15:29'!
doubleClick
	self browse! !

!FinderNode methodsFor: 'testing' stamp: 'CamilloBruni 2/21/2011 15:47'!
hasParentNode
	^ self parentNode isNil not! !

!FinderNode methodsFor: 'private' stamp: 'CamilloBruni 2/21/2011 16:05'!
inspectItem
	self item inspect! !

!FinderNode methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:44'!
keyStroke: anEvent
	(anEvent controlKeyPressed or: [ anEvent commandKeyPressed ]) ifFalse: [ ^ false ].
	anEvent keyCharacter == $b ifTrue: [ ^ self browse ].
	anEvent keyCharacter == $i ifTrue: [ ^ self inspectItem ].! !

!FinderNode methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/26/2011 12:51'!
menu: menu shifted: aBoolean
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browse.
	self addInspectMenuItem: menu.
		
	menu addLine.
	menu
		add: 'Expand All' translated
		target: self model
		selector: #expandAll.
	menu
		add: 'Collapse All' translated
		target: self model
		selector: #collapseAll.
	^menu! !

TestCase subclass: #MethodFinderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Finder-Tests'!

!MethodFinderTest commentStamp: 'sd 4/21/2011 16:54' prior: 0!
To do:
	- radix should be returned !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 18:08'!
testAllNumbers
	"self debug: #testAllNumbers"	

	self assert: (MethodFinder new load: #((5) 0.2   (2) 0.5)) allNumbers.
	self deny: (MethodFinder new load: #(('' $A) 'A')) allNumbers! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 16:10'!
testDegreeSin
	"self debug: #testDegreeSin"
	
	self assert: (MethodFinder new load: #( (0) 0  (30) 0.5  (45) 0.707106  (90) 1)) searchForOne asArray = #('data1 degreeSin') ! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 16:12'!
testIfTrueIfFalse
	"self debug: #testIfTrueIfFalse"
	
	self assert: (MethodFinder new load:  { { true. [3]. [4]}. 3.  { false. [0]. [6]}. 6}) searchForOne asArray = #('data1 ifTrue: data2 ifFalse: data3') ! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 16:13'!
testIsOdd
	"self debug: #testIsOdd"
	
	self assert: (MethodFinder new load: {#(1). true. #(2). false. #(5). true. #(10). false}) searchForOne asArray = #('data1 odd')! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 17:07'!
testIsRadix
	"self debug: #testIsRadix"
	
	self assert: ((MethodFinder new load: #((4 2) '2r100'   (255 16) '16rFF'    (14 8) '8r16')) searchForOne) asArray = #('data1 storeStringBase: data2')
		
		"Apparently the system should find :
		the #('data1 radix: data2' 'data1 printStringBase: data2' 'data1 storeStringBase: data2')"! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 18:10'!
testMethodFor
	"self debug: #testMethodFor"
	
	self assert: (MethodFinder  methodFor: {#(1). true. #(2). false. #(5). true. #(10). false}) =  '(data1 odd) (data1 anyMask: 1) (data1 allMask: 1) '! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 16:56'!
testPointY
	"self debug: #testPointY"
	
	self assert: (MethodFinder new load: {{Point x: 3 y: 4}. 4.  {Point x: 1 y: 5}. 5}) searchForOne asArray = #('data1 max' 'data1 y').
	self assert: (MethodFinder new load: {{Point x: 5 y: 4}. 4.  {Point x: 1 y: 5}. 5}) searchForOne asArray = #( 'data1 y').! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 16:57'!
testReciprocal
	"self debug: #testReciprocal"
	
	self assert: (MethodFinder new load: #((5) 0.2   (2) 0.5)) searchForOne asArray = #('data1 reciprocal')
! !

!MethodFinderTest methodsFor: 'test examples' stamp: 'sd 4/21/2011 16:11'!
testSubstraction
	"self debug: #testSubstraction"
	
	self assert: (MethodFinder new load: #((14 3) 11  (-10 5) -15  (4 -3) 7)) searchForOne asArray = #('data1 - data2')! !

MorphTreeModel subclass: #FinderUI
	instanceVariableNames: 'finder searchingTextArea sourceTextArea useRegExCheckbox forceSearch'
	classVariableNames: 'Icon SearchedTextList'
	poolDictionaries: ''
	category: 'Finder-UI'!

FinderUI class
	instanceVariableNames: 'searchedTextListMaxSize'!

FinderUI class
	instanceVariableNames: 'searchedTextListMaxSize'!

!FinderUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/18/2011 11:28'!
buildIcon

	| bitmap |
	bitmap := (Bitmap new: 256) copyFromByteArray:  #[0 0 0 0 0 0 0 0 0 0 0 0 19 0 0 0 117 75 72 58 215 114 102 61 255 133 115 49 255 130 109 30 242 109 89 19 188 75 61 14 94 37 33 22 5 0 0 107 0 0 0 0 1 10 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 56 32 35 43 210 132 125 100 255 208 190 122 255 255 230 112 253 255 229 84 253 255 220 57 254 255 206 24 255 221 174 4 255 142 111 5 174 60 50 17 25 0 0 44 0 0 0 0 1 2 2 8 0 0 0 0 0 0 0 0 52 40 42 48 232 161 156 138 255 242 228 175 255 255 249 164 255 255 231 133 255 219 193 99 255 190 163 64 255 205 169 37 255 235 186 8 255 231 181 0 255 163 129 3 188 64 53 15 16 0 0 61 0 0 0 0 2 18 20 29 13 0 0 0 200 150 149 145 255 245 239 217 255 255 255 213 255 228 214 166 209 161 151 113 128 118 111 80 105 101 94 67 150 95 84 43 246 126 102 15 255 199 156 1 255 221 173 0 255 139 110 4 134 41 35 19 0 0 0 0 0 0 0 0 100 105 104 100 255 222 219 209 255 255 255 249 255 236 230 204 175 151 147 132 25 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 78 0 0 29 239 106 85 9 255 194 152 1 255 190 148 0 231 96 77 10 45 0 0 29 0 0 0 0 198 147 144 131 255 255 250 216 255 255 255 223 229 176 173 157 36 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 116 21 21 22 255 141 111 4 255 197 154 0 255 121 95 3 109 42 37 17 0 0 0 0 248 166 159 131 254 255 246 184 255 247 234 184 158 140 135 115 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 26 0 0 55 246 94 75 7 255 180 141 0 255 143 112 1 154 67 55 14 3 0 0 174 255 166 155 113 253 255 241 154 255 228 211 145 134 127 120 93 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 0 0 43 226 82 66 12 255 173 136 0 255 151 118 1 172 67 55 11 11 0 0 44 249 153 140 92 254 255 234 121 255 242 217 121 165 122 113 78 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 21 0 0 56 243 87 70 8 255 169 132 0 255 139 109 1 161 65 53 13 7 0 0 80 203 121 110 69 255 255 221 90 255 255 229 94 241 144 127 64 51 0 0 35 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 118 24 22 22 255 127 99 4 255 171 133 0 255 109 85 3 109 48 41 18 0 0 0 0 114 72 67 48 255 195 165 55 255 255 225 59 255 214 179 51 196 94 81 32 37 0 0 26 0 0 0 0 0 0 0 0 4 0 0 202 102 14 16 25 242 98 78 7 255 162 127 0 255 167 131 0 255 87 69 8 68 0 0 25 0 0 0 0 15 0 0 29 203 98 83 28 255 221 178 23 253 255 208 20 255 196 157 14 242 108 86 10 178 66 54 12 161 63 52 12 212 75 61 12 255 121 96 6 255 166 130 0 254 161 126 0 255 155 121 1 255 126 98 3 182 54 45 13 16 0 0 64 0 0 0 0 53 0 0 23 232 102 82 10 255 207 162 2 255 240 188 0 255 215 169 0 255 192 151 2 255 179 141 3 255 180 141 1 255 181 141 0 255 176 137 0 254 156 123 0 254 149 116 0 255 159 124 0 255 114 89 4 149 35 31 17 0 0 0 0 0 0 0 0 55 0 0 28 203 85 68 13 255 150 118 5 255 199 156 1 255 208 163 0 255 195 153 0 255 186 146 1 255 150 117 2 255 103 81 4 255 130 102 2 255 158 124 0 255 156 122 1 255 159 124 1 255 91 72 6 0 0 0 0 0 0 0 0 0 0 0 0 20 0 0 45 111 44 37 20 194 88 70 12 238 100 80 10 247 101 81 10 224 86 70 10 164 67 55 13 98 28 26 22 183 57 46 13 255 107 84 4 255 153 120 2 253 155 121 1 255 140 109 3 0 0 0 0 0 0 0 0 2 34 22 0 0 0 0 0 0 0 0 0 18 0 0 36 37 0 0 24 41 0 0 24 32 0 0 23 8 0 0 60 0 0 0 0 13 0 0 62 114 32 30 21 232 66 53 10 255 101 79 4 248 78 62 6].
	^ Form extent: 16@16 depth: 32 bits: bitmap
	! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 2/25/2011 17:05'!
doAllSubscriptionsOn: aFinder to: anInstance
	self subscribesUpdateSourceCodeOn: aFinder to: anInstance.
	self subscribesResetEnvironmentOn: aFinder to: anInstance.
	self subscribesEnableUseRegExOn: aFinder to: anInstance.
	self subscribesDisableUseRegExOn: aFinder to: anInstance.
	self subscribesUpdateSelectedMethodOn: aFinder to: anInstance.
	self subscribesUpdateSelectedClassOn: aFinder to: anInstance.
	self subscribesUpdateListOn: aFinder to: anInstance! !

!FinderUI class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 12/16/2010 15:41'!
finderUISettingsOn: aBuilder
	<systemsettings>
		(aBuilder group: #finderUI)
		target: self;
		label: 'Finder' translated;
		description: 'Settings related to the finder' translated;
			with: [
				(aBuilder setting: #searchedTextListMaxSize)
				label: 'Size of the History' translated]! !

!FinderUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/18/2011 11:26'!
icon

	^ Icon ifNil: [Icon := self buildIcon]! !

!FinderUI class methodsFor: 'initialize-release' stamp: 'AlainPlantec 2/13/2011 22:20'!
initialize
	searchedTextListMaxSize := 15! !

!FinderUI class methodsFor: 'explanations' stamp: 'bvr 9/19/2010 18:41'!
methodFinderExplanation
	"The comment in the bottom pane"

	false ifTrue: [MethodFinder methodFor: #( (4 3) 7  (0 5) 5  (5 5) 10)].
		"to keep the method methodFor: from being removed from the system"

	^ 'Type a fragment of a selector in the top pane.  Accept it.

Or, use an example to find a method in the system.  Type receiver, args, and answer in the top pane with periods between the items.  3. 4. 7

Or, in this pane, use examples to find a method in the system.  Select the line of code and choose "print it".  

	MethodFinder methodFor: #( (4 3) 7  (0 5) 5  (5 5) 10).
This will discover (data1 + data2).

You supply inputs and answers and the system will find the method.  Each inner array is a list of inputs.  It contains the receiver and zero or more arguments.  For Booleans and any computed arguments, use brace notation.

	MethodFinder methodFor: { {1. 3}. true.  {20. 10}. false}.
This will discover the expressions (data1 < data2), (data2 > data1), and many others.

	MethodFinder methodFor: { {''29 Apr 1999'' asDate}. ''Thursday''.  
		{''30 Apr 1999'' asDate}. ''Friday'' }.
This will discover the expression (data1 weekday)

Receiver and arguments do not have to be in the right order.
See MethodFinder.verify for more examples.'! !

!FinderUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/25/2011 17:04'!
on: aFinder
	| instance |
	instance := self new finder: aFinder.
	self doAllSubscriptionsOn: aFinder to: instance.
	^instance.! !

!FinderUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/18/2011 11:27'!
resetIcon

	Icon := nil! !

!FinderUI class methodsFor: 'accessing' stamp: 'AlainPlantec 2/14/2011 01:00'!
searchedTextListMaxSize

	^ searchedTextListMaxSize ifNil: [searchedTextListMaxSize := 15]! !

!FinderUI class methodsFor: 'accessing' stamp: 'bvr 9/19/2010 19:19'!
searchedTextListMaxSize: anInteger

	self allInstancesDo: [:each | each searchedTextListMaxSize: anInteger].
	searchedTextListMaxSize := anInteger! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 2/25/2011 17:04'!
subscribesDisableUseRegExOn: aFinder to: anInstance.
	aFinder
		when: #disableUseRegEx
		send: #disableUseRegEx
		to: anInstance.! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 2/25/2011 17:04'!
subscribesEnableUseRegExOn: aFinder to: anInstance
	aFinder
		when: #enableUseRegEx
		send: #enableUseRegEx
		to: anInstance.! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'AlainPlantec 2/13/2011 22:20'!
subscribesResetEnvironmentOn: aFinder to: anInstance 
	aFinder
		when: #resetEnvironment
		send: #resetEnvironment
		to: anInstance! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 2/25/2011 17:05'!
subscribesUpdateListOn: aFinder to: anInstance
	aFinder
		when: #updateResultDictionary
		send: #updateList
		to: anInstance.! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 2/25/2011 17:04'!
subscribesUpdateSelectedClassOn: aFinder to: anInstance
	aFinder
		when: #updateSelectedClass
		send: #updateSelectedClass
		to: anInstance.! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 2/25/2011 17:04'!
subscribesUpdateSelectedMethodOn: aFinder to: anInstance
	aFinder
		when: #updateSelectedMethod
		send: #updateSelectedMethod
		to: anInstance.! !

!FinderUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 2/25/2011 17:04'!
subscribesUpdateSourceCodeOn: aFinder to: anInstance
	aFinder
		when: #updateSourceCode
		send: #updateSourceCode
		to: anInstance.! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 12/20/2010 10:11'!
addAllItems: aWindow
	| container toolbar height  btnFont  btnToolbar cst |
	toolbar := self buildSearchModeToolBar: aWindow.
	height := toolbar minExtent y.
	cst := 15.
	
	aWindow 
		addMorph: toolbar
		fullFrame: (LayoutFrame 
						fractions: (0 @ 0 corner: 1 @ 0)
						offsets: (0 @ 0 corner: 0 @ height)).
	aWindow
		addMorph: self buildPackagesTree buildContents
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0.58)
			offsets: (0@height corner: 0@0)).
	btnFont := StandardFonts buttonFont.
	btnToolbar := self buildBrowseToolBar: aWindow.
	aWindow
		addMorph: btnToolbar
		fullFrame: (LayoutFrame
						fractions: (0@0.58 corner: 1@0.58)
						offsets:(0@0 corner: 0@(btnFont height +cst))).
	aWindow 
		addMorph: self sourceTextArea
		fullFrame: (LayoutFrame
						fractions: (0@0.58 corner: 1@1)
						offsets:(0@(btnFont height +cst) corner: 0@0)).
! !

!FinderUI methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 21:28'!
addToSearchedTextList: aString 
	self searchedTextList: (self searchedTextList
			remove: aString
			ifAbsent: [];
			 yourself).
	self searchedTextList size = self searchedTextListMaxSize
		ifTrue: [self searchedTextList removeLast].
	self searchedTextList addFirst: aString ! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 9/17/2010 01:57'!
allClassesButtonAction

	self finder packagesSelection: self environment.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 22:31'!
allClassesButtonLabel
	^ 'All Packages'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
allClassesButtonState
	^false! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/16/2011 13:42'!
autoSelection
	| aString firstIndex interval string size |

	(self searchingString isEmpty or: [ self useRegEx] )
		ifTrue: [^ 0 to:0 ].
	
	self isSourceSymbol ifFalse: [^ 0 to: 0].
		
	aString := sourceTextArea text asString asLowercase.
	
	aString = self defaultExplanation asLowercase
		ifTrue: [ ^ 0 to: 0].
	
	string := self searchingString asLowercase.
	(string includes: $*)
		ifTrue: [| list lastIndex|
			list := string subStrings: '*'.
			firstIndex := aString findString: list first.
			lastIndex := (aString findString: list last startingAt: firstIndex) + list last size - 1.
			interval := firstIndex to: lastIndex]
		ifFalse: [| index |
			firstIndex := aString findString: string.
			size := string size.
			interval := firstIndex to: (firstIndex + size - 1)].
		
	^ firstIndex = 0 
		ifTrue: [ 0 to:0 ]
		ifFalse: [interval]! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/3/2011 13:28'!
browseButtonAction

	self selectedNode browse.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
browseButtonLabel
	^'Browse'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/3/2011 13:29'!
browseButtonState
	^self selectedClass isNil or: [self selectedMethod isNil]! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildAllClassesButton
	^ PluggableButtonMorph 
			on: self 
			getState: #allClassesButtonState 
			action: #allClassesButtonAction 
			label: #allClassesButtonLabel! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildAllTextArea
	self buildSearchingTextArea.
	self buildSourceTextArea.! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/15/2010 02:03'!
buildBrowseButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #browseButtonState 
			action: #browseButtonAction 
			label: #browseButtonLabel)
			hResizing: #spaceFill! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/16/2010 22:59'!
buildBrowseToolBar: aWindow
	| toolbar |
	toolbar := aWindow newToolbar: {
		self buildBrowseButton.
		self buildSendersButton.
		self buildImplementorsButton.
		self buildVersionsButton.
		self buildInheritanceButton.
		self buildHierarchyButton}.
	^toolbar hResizing: #shrinkWrap! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 3/4/2011 12:18'!
buildDescriptionOf: aClass

	| stream |
	stream := WriteStream on: ''.
	stream 
		nextPutAll: aClass definition.
	aClass hasComment
		ifTrue: [
			stream
				nextPut: Character cr;
				nextPut: Character cr;
				nextPut: Character cr;
				nextPutAll: aClass comment].

	^ stream contents! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildEnvironmentButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #environmentButtonState 
			action: #environmentButtonAction 
			label: #environmentButtonLabel)
			beSticky! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/15/2010 02:03'!
buildHierarchyButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #hierarchyButtonState 
			action: #hierarchyButtonAction 
			label: #hierarchyButtonLabel)
			hResizing: #spaceFill! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/15/2010 02:04'!
buildImplementorsButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #implementorsButtonState 
			action: #implementorsButtonAction 
			label: #implementorsButtonLabel)
			hResizing: #spaceFill! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/15/2010 02:04'!
buildInheritanceButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #inheritanceButtonState 
			action: #inheritanceButtonAction 
			label: #inheritanceButtonLabel)
			hResizing: #spaceFill! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 2/25/2011 17:03'!
buildPackagesTree
	| tree | 
	tree := (MorphTreeMorph on: self) doubleClickSelector: #doubleClick;
				beSingle;
				keystrokeActionSelector: #keyStroke:;
				autoDeselection: false;
				rowInset: 4;
				columnInset: 4;
				getMenuSelector: #menu:shifted:;
				rowColorForEven: Color lightGray muchLighter odd: Color white.

	^ tree! !

!FinderUI methodsFor: 'items creation' stamp: 'AlainPlantec 2/13/2011 22:30'!
buildRegExChooser
	| string btnHeight btnWidth |
	string := 'Regexp'.
	btnHeight := StandardFonts buttonFont height + 8.
	btnWidth := 0.
	string do: [:c | btnWidth := btnWidth + (StandardFonts buttonFont widthOf: c)].
	^useRegExCheckbox := (CheckboxMorph 
									on: self finder
									selected: #useRegEx
									changeSelected: #useRegEx:)
									beCheckbox;
									vResizing: #rigid;
									height: btnHeight;
									width: btnWidth + 30;
									label: string! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 2/17/2011 11:06'!
buildSearchButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #searchButtonState 
			action: #searchButtonAction 
			label: #searchButtonLabel)
			hResizing: #shrinkWrap! !

!FinderUI methodsFor: 'items creation' stamp: 'FernandoOlivero 4/12/2011 09:45'!
buildSearchModeDropListIn: aWindow
			^(self theme 
				newDropListIn: aWindow
				for:self				
				list: #searchModesList
				getSelected: #currentSearchMode
				setSelected: #currentSearchMode:
				getEnabled: nil
				useIndex: false 
				help: self searchModeHelpText) hResizing: #rigid; width: 120; yourself
! !

!FinderUI methodsFor: 'items creation' stamp: 'MarcusDenker 5/15/2011 15:21'!
buildSearchModeToolBar: aWindow
	^aWindow newToolbar: {
		self buildSearchingTextArea.
		self buildSearchButton.
		self buildRegExChooser.
		self buildSearchModeDropListIn: aWindow.
		self buildEnvironmentButton.
		self buildAllClassesButton}.! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/13/2010 17:28'!
buildSearchingTextArea
	^ searchingTextArea := 
		(EditableDropListMorph
				on: self
				list: #searchedTextList
				selected: #searchingString
				changeSelected: #searchingAccept:
				useIndex: false 
				addToList: #addToSearchedTextList:
				class: String
				getEnabled: nil) hResizing: #spaceFill; 
				ghostText: 'Hit return to accept' translated.

	! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/15/2010 02:04'!
buildSendersButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #sendersButtonState 
			action: #sendersButtonAction 
			label: #sendersButtonLabel)
			hResizing: #spaceFill! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/16/2011 13:18'!
buildSourceTextArea

	sourceTextArea := PluggableTextMorph
				on: self
				text: #sourceCode
				accept: #compileSource:notifying:
				readSelection: #autoSelection
				menu: #msgPaneMenu:shifted:.
				
	sourceTextArea askBeforeDiscardingEdits: true.
				
	self updateSourceCode.
	^ sourceTextArea! !

!FinderUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/15/2010 02:04'!
buildVersionsButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #versionsButtonState 
			action: #versionsButtonAction 
			label: #versionsButtonLabel)
			hResizing: #spaceFill! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 9/17/2010 02:50'!
collectFromPackages: aCollection
	self packagesSelection: (self environment select: [:each | aCollection includes: each category ])! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 4/14/2011 11:43'!
compileSource: aString notifying: aController

	| association class method |
	(self selectedClass isNil or: [ self selectedMethod isNil ])
		ifTrue:[
			self changed: ##clearUserEdits.
			^self].
	class := self selectedClass.
	method := class methodDict at: self selectedMethod.
	(class compile: (aString asString) classified: method category notifying: aController)
			ifNil: [^ self ]
			ifNotNil: [:selector |
				self changed: #clearUserEdits ]! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/18/2010 14:41'!
constructPackagesSet
	| list result |
	list := (self environment difference: self packagesSelection).
	result := OrderedCollection new.
	'Building Packages'
	 	displayProgressAt: Display center
		from: 0 to: list size
		during:[ :bar | 
			list doWithIndex: [:each :i | 
				bar value: i.
				result add: each category]].
			
	^result asSet asSortedCollection: [:a :b | a<b]! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/17/2010 03:02'!
constructPackagesSet: aList
	| result |
	result := OrderedCollection new.
	'Building Packages'
	 	displayProgressAt: Display center
		from: 0 to: aList size
		during:[ :bar | 
			aList doWithIndex: [:each :i | 
				bar value: i.
				result add: each category]].
	
		^(result reject: [:each | each isNil]) asSet asSortedCollection: [:a :b | a<b].! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/14/2010 17:44'!
currentSearchMode
	^self finder currentSearchMode! !

!FinderUI methodsFor: 'accessing' stamp: 'bvr 9/19/2010 18:27'!
currentSearchMode: aSymbol
	
	self finder searchingStringSilently: self searchingTextArea contentMorph textMorph text asString.
	self searchingTextArea contentMorph textMorph hasUnacceptedEdits:false.
	self finder currentSearchMode: aSymbol.
	.! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/17/2011 10:54'!
defaultExplanation
^
'The Finder can be used in 4 different ways:
	- Selectors: your research is done among selectors
	- Classes : your research is done among classes names
	- Source : your research is done among all the source code
	- Examples : your research uses the Method Finder behavior 
			   (for further informations, print ''FinderUI methodFinderExplanation'')
			
In these four modes, you can also tick the ''Use RegEx'' checkbox.
If you pick this box, your search will be done using regular expressions instead of just matching.

The ''Select classes'' button opened a dialog window  to select which classes will be used for the search.
The ''All classes'' button is used to reset the classes selection.'! !

!FinderUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 9/15/2010 02:47'!
defaultWindowLabel
	^'Finder'.! !

!FinderUI methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 9/15/2010 01:47'!
disableUseRegEx
	useRegExCheckbox isSelected
		ifTrue: [ useRegExCheckbox toggleSelected].
	useRegExCheckbox enabled: false.
! !

!FinderUI methodsFor: 'do it requirements' stamp: 'BenjaminVanRyseghem 4/14/2011 11:47'!
doItContext

	^ nil! !

!FinderUI methodsFor: 'do it requirements' stamp: 'MarcusDenker 6/21/2011 16:33'!
doItReceiver

	^ self selectedClass ifNotNil: [:selectedClass | selectedClass theNonMetaClass].! !

!FinderUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/25/2011 16:48'!
doubleClick
	self selectedNode doubleClick! !

!FinderUI methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 9/15/2010 01:41'!
enableUseRegEx
	useRegExCheckbox 
		enabled: true;
		updateEnabled! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/13/2010 16:12'!
environment

	^ self finder environment.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 9/16/2010 01:16'!
environmentButtonAction
	self openPackageChooser! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 22:48'!
environmentButtonLabel
	^ 'Choose Packages'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environmentButtonState
	^false.! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/13/2010 16:02'!
finder
	^finder! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/13/2010 16:03'!
finder: aFinder
	finder := aFinder! !

!FinderUI methodsFor: 'searching' stamp: 'BenjaminVanRyseghem 11/11/2010 23:54'!
forSelectorsDo: selectorBlock forClassNamesDo: classNamesBlock forSourceDo: sourceBlock forPatternDo: patternBlock

	self currentSearchMode = #Selectors
		ifTrue: [^selectorBlock value].
	self currentSearchMode = #Classes
		ifTrue: [^classNamesBlock value].
	self currentSearchMode = #Source
		ifTrue: [^sourceBlock value].
	self currentSearchMode = #Examples
		ifTrue: [^patternBlock value].! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2011 16:41'!
forceSearch

	 ^ forceSearch ifNil: [forceSearch := false].! !

!FinderUI methodsFor: 'private' stamp: 'MarcusDenker 4/29/2011 00:34'!
hierarchy
	
		self selectedClass ifNotNil: [ :class |
			self selectedMethod
				ifNil: [SystemNavigation new browseHierarchy: class]
				ifNotNil: [:selector | 
					SystemNavigation new browseHierarchy:class selector: selector]]! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
hierarchyButtonAction
	self hierarchy.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
hierarchyButtonLabel
	^'Hierarchy'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
hierarchyButtonState
	^self selectedClass isNil.! !

!FinderUI methodsFor: 'private' stamp: 'MarcusDenker 4/29/2011 00:34'!
implementors

			self selectedMethod ifNotNil: [ :selector |
		 		SystemNavigation new browseImplementorsOf: selector name: 'Implementors of ', selector asString autoSelect: nil]! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
implementorsButtonAction
	self implementors.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
implementorsButtonLabel
	^'Implementors'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
implementorsButtonState
	^self selectedMethod isNil | self isClassNamesSymbol.! !

!FinderUI methodsFor: 'private' stamp: 'MarcusDenker 4/29/2011 00:34'!
inheritance
	
		self selectedClass ifNotNil: [ :class |.
				self selectedMethod ifNotNil: [:selector | 
					SystemNavigation new methodHierarchyBrowserForClass: class selector: selector]]! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
inheritanceButtonAction
	self inheritance.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
inheritanceButtonLabel
	^'Inheritance'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
inheritanceButtonState
	^self selectedClass isNil | self isClassNamesSymbol.! !

!FinderUI methodsFor: 'display' stamp: 'AlainPlantec 2/13/2011 21:17'!
initialExtent
	^700 @ 500! !

!FinderUI methodsFor: 'mode list' stamp: 'BenjaminVanRyseghem 9/14/2010 17:46'!
isClassNamesSymbol
	^self currentSearchMode = #Classes! !

!FinderUI methodsFor: 'mode list' stamp: 'BenjaminVanRyseghem 9/18/2010 15:30'!
isPatternSymbol
	^self finder isPatternSymbol! !

!FinderUI methodsFor: 'mode list' stamp: 'BenjaminVanRyseghem 9/15/2010 00:10'!
isSelectorsSymbol
	^self finder isSelectorsSymbol! !

!FinderUI methodsFor: 'mode list' stamp: 'BenjaminVanRyseghem 9/14/2010 23:54'!
isSourceSymbol
	^self finder isSourceSymbol! !

!FinderUI methodsFor: 'events handling' stamp: 'StephaneDucasse 3/12/2011 15:07'!
keyStroke: event
	self selectedNode ifNotNil: [:node | node keyStroke: event]! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
labelFont
	^StandardFonts defaultFont! !

!FinderUI methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 2/26/2011 12:53'!
menu: menu shifted: b 
	^ self selectedNode menu: menu shifted: b ! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
msgPaneMenu: aMenu shifted: shifted
	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!FinderUI methodsFor: 'display' stamp: 'AlainPlantec 2/13/2011 22:03'!
open
	| window |
	window := StandardWindow new model: self.
	self addAllItems: window.
	window setLabel: self defaultWindowLabel.
	window openInWorld.
	self searchingTextArea contentMorph takeKeyboardFocus! !

!FinderUI methodsFor: 'private' stamp: 'AlainPlantec 2/13/2011 21:07'!
openPackageChooser
	(DialogItemsChooser
		on: self
		unselectedItems: self constructPackagesSet
		selectedItems: (self constructPackagesSet: self packagesSelection)
		selectedItemsSetterSelector: #collectFromPackages: 
		title: 'Package Chooser'
		unselectedItemsLabel: 'Unselected Packages' translated
		selectedItemsLabel: 'Selected Packages' translated) openInWorld! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/16/2010 21:09'!
packagesSelection
	^self finder packagesSelection! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/17/2010 02:16'!
packagesSelection: aCollection

	self finder packagesSelection: aCollection.! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'AlainPlantec 2/13/2011 22:28'!
removeStyler
	sourceTextArea
		ifNotNil: [sourceTextArea
				styler: (NullTextStyler new view: sourceTextArea)] ! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
resetEnvironment
	self triggerEvent: #resetEnvironment! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/15/2010 01:21'!
resetSearchedTextList
	self searchedTextList removeAll.! !

!FinderUI methodsFor: 'tree behavior' stamp: 'BenjaminVanRyseghem 9/14/2010 16:35'!
resultDictionary 
	^self finder resultDictionary ! !

!FinderUI methodsFor: 'tree behavior' stamp: 'BenjaminVanRyseghem 9/18/2010 15:08'!
rootItems
	^self resultDictionary keys sort:[:a :b | a name  < b name]! !

!FinderUI methodsFor: 't - accessing' stamp: 'AlainPlantec 2/13/2011 21:23'!
rootNodeClassFromItem: anItem 
	"To have the good class for my nodes, I ask my owner,
	because he is the only one who knows his state"
	^ self 
		forSelectorsDo: [FinderMethodNode]
		forClassNamesDo: [FinderClassNode]
		forSourceDo: [FinderMethodNode]
		forPatternDo: [FinderMethodNode] ! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 2/17/2011 11:20'!
searchButtonAction
	
	forceSearch := true.
	self searchingTextArea contentMorph acceptTextInModel.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonLabel
	^'Search'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonState
	^false.! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2010 16:46'!
searchModeHelpText
	^'Choose the mode for the search'! !

!FinderUI methodsFor: 'mode list' stamp: 'BenjaminVanRyseghem 11/11/2010 23:32'!
searchModesList
	^#(Selectors Classes Source Examples)! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/14/2010 14:25'!
searchedTextList
	^SearchedTextList ifNil: [ SearchedTextList := OrderedCollection new]! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 14:55'!
searchedTextList: aCollection

	SearchedTextList := aCollection! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 13:42'!
searchedTextListMaxSize
	^self class searchedTextListMaxSize! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:39'!
searchedTextListMaxSize: anInteger
	[self searchedTextList size > anInteger]
		whileTrue: [ self searchedTextList removeLast].
	self changed: #searchedTextList.! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 2/17/2011 11:21'!
searchingAccept: aText

	self forceSearch
		ifFalse: [aText asString = self searchingString ifTrue: [^self]].
	self searchingString: aText asString.
	forceSearch := false.! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/13/2010 16:06'!
searchingString
	^self finder searchingString! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/23/2011 15:27'!
searchingString: aString

	^self finder searchingString: aString! !

!FinderUI methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 21:48'!
searchingTextArea
	^searchingTextArea ifNil: [self buildSearchingTextArea]! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/13/2010 16:11'!
selectedClass
	^ self finder selectedClass! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/13/2010 16:13'!
selectedMethod
	^ self finder selectedMethod! !

!FinderUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/25/2011 16:42'!
selection: anObject
	
	super selection: anObject.
	self finder selection: anObject! !

!FinderUI methodsFor: 'private' stamp: 'MarcusDenker 4/29/2011 00:35'!
senders

	self selectedMethod 
		ifNotNil: [ :selector |.
			 	SystemNavigation new browseSendersOf: selector name: 'Senders of ', selector asString autoSelect: selector asString].! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sendersButtonAction
	self senders.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sendersButtonLabel
	^'Senders'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sendersButtonState
	^self selectedMethod isNil | self isClassNamesSymbol.! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 3/4/2011 15:27'!
sourceCode

	^ self selectedClass isNil
		ifTrue: [
			self removeStyler.
			self defaultExplanation]
		ifFalse:[
			self selectedMethod isNil
				ifTrue: [
					self removeStyler.
					self buildDescriptionOf: self selectedClass]
				ifFalse:[
					| method |
					self useDefaultStyler.
					method := self isPatternSymbol
								ifTrue: [self finder findSelector: self selectedMethod]
								ifFalse: [self selectedMethod].
					self sourceTextArea styler classOrMetaClass: self selectedClass.
					(self selectedClass >> method) getSource]]! !

!FinderUI methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 21:41'!
sourceTextArea
	^sourceTextArea ifNil: [self buildSourceTextArea]! !

!FinderUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/18/2011 11:29'!
taskbarIcon

	^ self class icon! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 2/25/2011 17:07'!
updateList
	"I update the list of my tree"
	
	self changed: #rootNodes.! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/15/2010 02:16'!
updateSelectedClass
	self changed: #selectedClass! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/15/2010 02:16'!
updateSelectedMethod
	self changed: #selectedMethod! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 5/16/2011 13:38'!
updateSourceCode
	
	self changed: #sourceCode.! !

!FinderUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 3/4/2011 15:22'!
useDefaultStyler
	self sourceTextArea useDefaultStyler! !

!FinderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/15/2010 02:45'!
useRegEx
	^ self finder useRegEx! !

!FinderUI methodsFor: 'items creation' stamp: 'AlainPlantec 2/13/2011 21:44'!
useRegExCheckbox
	^ useRegExCheckbox ifNil: [self buildRegExChooser]
! !

!FinderUI methodsFor: 'private' stamp: 'MarcusDenker 4/29/2011 00:36'!
versions
	self selectedClass ifNotNil: [ :class |
		self selectedMethod ifNotNil: [:selector |
			Smalltalk tools versionBrowser browseVersionsForClass: class selector: selector]]! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
versionsButtonAction
	self versions.! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
versionsButtonLabel
	^'Versions'! !

!FinderUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
versionsButtonState
	^self selectedClass isNil | self isClassNamesSymbol.! !

Object subclass: #Finder
	instanceVariableNames: 'searchingString selectedMethod selectedClass packagesSelection currentSearchMode environment resultDictionary useRegEx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Finder-UI'!

!Finder commentStamp: 'BenjaminVanRyseghem 9/15/2010 11:17' prior: 0!
I'm the finderUI model in the MVC pattern.

I'm compute the search string and I construct a resultDictionary.
Then I throw events everywhere and my views are redrawn.!

!Finder class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 3/20/2011 01:29'!
finderMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: #Finder)
		action: [self open];
		order: 0;
		parent: #Tools;
		help: 'Looking for something ?';
		icon: self icon! !

!Finder class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 3/18/2011 11:30'!
icon
	"My menu icon"
	^ FinderUI icon! !

!Finder class methodsFor: 'menu' stamp: 'AlainPlantec 2/14/2011 21:25'!
open
	^ self new open! !

!Finder class methodsFor: 'tools registry' stamp: 'IgorStasenko 2/19/2011 03:02'!
registerToolsOn: registry
	"Add ourselves to registry. See [Smalltalk tools]" 

	registry register: self as: #finder

	! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:39'!
computeListOfClasses: aString
	"Compute in the case I'm searching class names"
	
	| list result originalList |
	originalList := self packagesSelection.
	result := OrderedCollection new.
	
	'Scanning'
		displayProgressAt: Display center
			from: 0 to: originalList size
			during: [:bar |  	
				self useRegEx
					ifTrue: [ originalList doWithIndex: [:each :i | 
							bar value: i.
							(each name substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: aString])
								ifTrue: [
									result add: each.
									result add: each classSide]]]
					ifFalse: [ 
						originalList doWithIndex: [:each :i | 
							bar value: i.
							(each name includesSubstring: aString caseSensitive: false)
								ifTrue: [
									result add: each.
									result add: each classSide]]]].
	^result! !

!Finder methodsFor: 'private' stamp: 'jb 7/1/2011 10:53'!
computeWithMethodFinder: aString
	"Compute the selectors for the single example of receiver and args, in the very top pane" 

	| data result resultArray dataStrings mf dataObjects aa statements |
	((aString includes: $.) not) ifTrue: [^#()].
	data := aString.
	"delete trailing period. This should be fixed in the Parser!!"
 	[data last isSeparator] whileTrue: [data := data allButLast]. 
	data last = $. ifTrue: [data := data allButLast]. 	"Eval"
	mf := MethodFinder new.
	data := mf cleanInputs: data.	"remove common mistakes"
	[dataObjects := self class evaluatorClass evaluate: '{', data, '}'] on: SyntaxErrorNotification do: [:e | 
		self inform: 'Syntax Error: ', e errorMessage. 
		self contents: (e errorCode allButFirst allButLast).
		^#().]. "#( data1 data2 result )"
	statements := (self class evaluatorClass new parse: 'zort ' , data in: Object notifying: nil)
						body statements select: [:each | (each isKindOf: ReturnNode) not].
 	dataStrings := statements collect:
				[:node | String streamContents:
					[:strm | (node isMessage) ifTrue: [strm nextPut: $(].
					node shortPrintOn: strm.
					(node isMessage) ifTrue: [strm nextPut: $)].]].
	dataObjects size < 2 ifTrue: [self inform: 'If you are giving an example of receiver, \args, and result, please put periods between the parts.\Otherwise just type one selector fragment' withCRs. ^#()].
 	dataObjects := Array with: dataObjects allButLast with: dataObjects last. "#( (data1
  data2) result )" 
	result := mf load: dataObjects; findMessage.
	(result first beginsWith: 'no single method') ifFalse: [
		aa := self testObjects: dataObjects strings: dataStrings.
		dataObjects := aa second.  dataStrings := aa third].
	resultArray := self listFromResult: result. 
	resultArray isEmpty ifTrue: [self inform: result first].
	dataStrings size = (dataObjects first size + 1) ifTrue:
		[resultArray := resultArray collect: [:expression | | newExp |
		newExp := expression.
		dataObjects first withIndexDo: [:lit :i |
			newExp := newExp copyReplaceAll: 'data', i printString
							with: (dataStrings at: i)].
		newExp, ' --> ', dataStrings last]].
 	^ resultArray! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:40'!
constructClassNamesDictionary
	"Construct the dictionary in the case I'm searching in class names"
	
	| result listOfClasses listOfAssociations |
	listOfClasses := self computeListOfClasses: self searchingString.
	result := Dictionary new.
	listOfClasses do: [:each | result at: each put: (each methodDict keys sort: [:a :b | a < b])].
	self resultDictionary: result.! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:40'!
constructDictionary
	"I construct the adequate dictionary regarding the search mode"

	| symbol |
	self searchingString isEmpty ifTrue: [ ^ self resultDictionary: Dictionary new].
	symbol := self currentSearchMode.
	symbol = #Selectors
		ifTrue: [ ^self constructDictionaryWithMessagesNameSearch: self searchingString].
	symbol = #Classes
		ifTrue: [ ^self constructClassNamesDictionary].
	symbol = #Source
		ifTrue: [ ^self constructSourceDictionary].
	symbol = #Examples
		ifTrue: [ ^self constructDictionaryWithMethodFinder: self searchingString].
	self error: 'Error with radio buttons'! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:40'!
constructDictionaryWithMessagesNameSearch: aString
	"Construct dictionary when searching for selector"
	
	| result listOfMethods |
	result := Dictionary new.
	listOfMethods := self messagesNameSearch: aString.
	listOfMethods do: [:method || key value |
			key := method selector.
			value := method methodClass.
			(result includesKey: key)
				ifTrue: [ (result at: key) add: value]
				ifFalse: [ result at: key put: (OrderedCollection new add: value; yourself)]].
	self resultDictionary: result.! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:48'!
constructDictionaryWithMethodFinder: aString
	"construct dictionary when searching patterns"

	| result listOfStrings listOfSelectors |
	result := Dictionary new.
	listOfStrings := self computeWithMethodFinder: aString.
	listOfSelectors := listOfStrings collect: [:each | self findSelector: each].
	self packagesSelection do: [ :class | 
		class methodDict do: [: method || index |
			(( index := listOfSelectors indexOf: method selector) = 0) not
				ifTrue: [ | key value receiver receiverString|
					key := listOfStrings at: index.
					value := method methodClass.
					(result includesKey: key)
						ifTrue: [ (result at: key) add: value]
						ifFalse: [ result at: key put: (OrderedCollection new add: value; yourself)]]]].
	self resultDictionary: result.! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:48'!
constructSourceDictionary
"construct dictionary when searching source"
	| result listOfMethods |
	
	result := Dictionary new.
	listOfMethods := self sourceSearch: self searchingString.
	listOfMethods do: [:method || key value |
			key := method selector.
			value := method methodClass.
			(result includesKey: key)
				ifTrue: [ (result at: key) add: value]
				ifFalse: [ result at: key put: (OrderedCollection new add: value; yourself)]].
	self resultDictionary: result.! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:49'!
currentSearchMode
	"Getter"
	"I shoud answer a Symbol in :
		- #Selectors
		- #Classes
		- #Source
		- #Examples"
	
	 ^ currentSearchMode! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:49'!
currentSearchMode: aSymbol
	"Setter"
	"If #Examples is selected, I disable the RegEx checkbo. Then I rebuild the resultDictionary"

	currentSearchMode := aSymbol.
		aSymbol == #Examples
			ifTrue: [ self disableUseRegEx]
			ifFalse:[ self enableUseRegEx].
	self constructDictionary! !

!Finder methodsFor: 'initialize-release' stamp: 'sd 4/21/2011 15:49'!
defaultEnvironment
	 ^ Smalltalk globals allClassesAndTraits.! !

!Finder methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defaultPackagesSelection
	 ^ self environment! !

!Finder methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defaultString
	^''! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:49'!
disableUseRegEx
	"send a disable useRegEx dropbox event"
	^ self triggerEvent: #disableUseRegEx! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:49'!
enableUseRegEx
	"send a enable useRegEx dropbox event"
	^ self triggerEvent: #enableUseRegEx! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:50'!
environment
	"Gette: I should be a classes collection"
	 ^ environment reject: [:each |  each isObsolete].! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:50'!
environment: aCollection

	 environment := aCollection! !

!Finder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
findSelector: aString
	"Answer the selector of aString."

	| example tokens |
	example := aString.
	tokens := Scanner new scanTokens: example.
	tokens size = 1 ifTrue: [^ tokens first].
	tokens first == #'^' ifTrue: [^ nil].
	(tokens second includes: $:) ifTrue: [^ example findSelector].
	Symbol hasInterned: tokens second ifTrue: [:aSymbol | ^ aSymbol].
	^ nil! !

!Finder methodsFor: 'initialize-release' stamp: 'sd 4/21/2011 15:50'!
initialize
	super initialize.
	searchingString := self defaultString.
	environment := self defaultEnvironment.
	packagesSelection := self defaultPackagesSelection.
	resultDictionary := Dictionary new.
	currentSearchMode := #Selectors.
	useRegEx := false.
	! !

!Finder methodsFor: 'checkbox' stamp: 'sd 4/21/2011 15:50'!
isPatternSymbol
	"Answer if the current mode is Examples"
	^self currentSearchMode = #Examples! !

!Finder methodsFor: 'checkbox' stamp: 'sd 4/21/2011 15:51'!
isSelectorsSSourceFiles 
	"Answer if the current mode is Selectors"
	^self currentSearchMode = #Selectors! !

!Finder methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 9/15/2010 23:23'!
isSelectorsSymbol
"answer if the current mode is Selectors"
	^self currentSearchMode = #Selectors! !

!Finder methodsFor: 'checkbox' stamp: 'sd 4/21/2011 15:50'!
isSourceSymbol
	"answer if the current mode is Source"
	^self currentSearchMode = #Source! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:57'!
listFromResult: resultOC
	"The argument, resulOC, is of the form #('(data1 op data2)' '(...)'). Answer a sorted array."

	(resultOC first beginsWith: 'no single method') ifTrue: [^ #()].
	^ resultOC sort: [:a :b | 
		(a copyFrom: 6 to: a size) < (b copyFrom: 6 to: b size)].
! !

!Finder methodsFor: 'private' stamp: 'EliotMiranda 6/7/2011 10:03'!
messagesNameSearch: aStringArg
"I'm searching for selectors"
	| aString list result originalList bool starting exactMatch |
	originalList := self packagesSelection.
	result := OrderedCollection new.
	aString := (exactMatch := aStringArg first = $" and: [aStringArg last = $"])
				ifTrue: [(Symbol findInterned: (aStringArg copyFrom: 2 to: aStringArg size - 1))
							ifNil: [^result]
							ifNotNil: [:aSymbol| aSymbol]]
				ifFalse: [aStringArg].
	'Scanning'
		displayProgressAt: Display center
		from: 0 to: originalList size
		during:[ :bar | 
			self useRegEx
				ifTrue: [
					originalList doWithIndex: [:class :i || temp |
						bar value: i.
						temp := class methodDict select: [:method | (method selector asString) substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: aString]].
						temp addAll: (class classSide methodDict select: [:method | (method selector asString) substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: aString]]).
						result addAll: temp]]
				ifFalse: [
					originalList doWithIndex: [:class :i || temp |
						bar value: i.
						temp := class methodDict select:
							[:method |
							exactMatch
								ifTrue: [method selector = aString]
								ifFalse: [method selector asString includesSubstring: aString caseSensitive: false]].
						temp addAll: (class classSide methodDict select:
							[:method |
							exactMatch
								ifTrue: [method selector = aString]
								ifFalse: [method selector asString includesSubstring: aString caseSensitive: false]]).
						result addAll: temp]]].
	^result! !

!Finder methodsFor: 'display' stamp: 'FernandoOlivero 5/30/2011 09:59'!
open
	^ (self uiClass on: self) open! !

!Finder methodsFor: 'display' stamp: 'FernandoOlivero 5/30/2011 09:59'!
openInWorld
	^ self open! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:56'!
packagesSelection
	"I should be a selection of classes"
	^packagesSelection! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:56'!
packagesSelection: aCollection
	"I change the classes selection, then I rebuild the result dictionary"
	packagesSelection :=  aCollection.
	self constructDictionary.! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:56'!
resetEnvironment
	"I send an event when I reset the environment"
	self environment: self defaultEnvironment.
	self triggerEvent: #resetEnvironment.! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
resultDictionary
	"I should answer a dictionary"
	^resultDictionary! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
resultDictionary: aDictionary
	"When the result dictionary is update, I send an event through the whole universe"

	resultDictionary := aDictionary.
	self triggerEvent: #updateResultDictionary.
	self selectedMethod: nil.
	self selectedClass: nil.
	self triggerEvent: #updateSourceCode.! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
searchingString

	^searchingString! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
searchingString: aString
	"When the search string is modified (in fact, when I make a search) I rebuild the result dictionary"

	searchingString := aString.
	self constructDictionary.! !

!Finder methodsFor: 'accessing' stamp: 'bvr 9/19/2010 18:27'!
searchingStringSilently: aString
	searchingString := aString.
! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
selectedClass

	^selectedClass! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
selectedClass: aClass
	"When the class seletion is changed, I send an event to UI"
	selectedClass := aClass.
	self triggerEvent: #updateSelectedClass
	! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
selectedMethod
	"I should answer a CompiledMethod"
	^selectedMethod! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
selectedMethod: aMethod
	"When the method seletion is changed, I send an event to UI"
	selectedMethod := aMethod.
	self triggerEvent: #updateSelectedMethod! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:55'!
selection: anObject
	"anObject is a selection holder"
	"Depending of the value of currentSearchMode, I fill selectedMethod and SelectedClass with the good items."
	"Then, I update the source code text area"

	| path method class |
	(anObject isNil or: [anObject selectedNodePath isNil]) ifTrue: [
		self selectedClass: nil.
		self selectedMethod: nil.
		^self].
	path := anObject selectedNodePath.
	self currentSearchMode = #Selectors
		ifTrue: [
			method := path first.
			class := path at: 2 ifAbsent:[nil]].
	self currentSearchMode = #Classes
		ifTrue: [
			class := path first.
			method := path at: 2 ifAbsent:[nil]].
	self currentSearchMode = #Source
		ifTrue: [
			method := path first.
			class := path at: 2 ifAbsent:[nil]].
	self currentSearchMode = #Examples
		ifTrue: [
			method := path first.
			class := path at: 2 ifAbsent:[nil]].
	self selectedClass: (class
							ifNil: [nil] 
							ifNotNilDo: [:each | each item]).
	self selectedMethod: (method
							ifNil: [nil]
							ifNotNilDo: [:each | each item]).
	self triggerEvent: #updateSourceCode! !

!Finder methodsFor: 'private' stamp: 'MarcusDenker 4/22/2011 09:26'!
sourceSearch: aResearchString
"I'm searching in sources"
	| originalList result aString |
	aString := aResearchString.
	
	originalList := self packagesSelection.
	result := OrderedCollection new.
	
	'Scanning' 
		displayProgressAt: Display center
		from: 0 to: originalList size
		during: [:bar |  

		self useRegEx
			ifTrue:[
				originalList doWithIndex: [:class :i || temp |
					bar value: i.
					temp := class methodDict select: [:method | (method getSource asString) substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: aString]].
					temp addAll: (class classSide methodDict select: [:method | (method getSource asString) substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: aString]]).
				result addAll: temp]]
			ifFalse:[
				originalList doWithIndex: [:class :i || temp |
					bar value: i.
					temp := class methodDict select: [:method | method getSource asString includesSubstring: aString caseSensitive: false].
					temp addAll: (class classSide methodDict select: [:method | method getSource asString includesSubstring: aString caseSensitive: false]).
				result addAll: temp]]].
	^result.! !

!Finder methodsFor: 'private' stamp: 'sd 4/21/2011 15:53'!
testObjects: dataObjects strings: dataStrings
	| dataObjs dataStrs selectors classes didUnmodifiedAnswer |
	"Try to make substitutions in the user's inputs and search for the selector again.
1 no change to answer.
2 answer Array -> OrderedCollection.
2 answer Character -> String
4 answer Symbol or String of len 1 -> Character
	For each of these, try straight, and try converting args:
Character -> String
Symbol or String of len 1 -> Character
	Return array with result, dataObjects, dataStrings.  Don't ever do a find on the same set of data twice."

	dataObjs := dataObjects.  dataStrs := dataStrings.
	selectors := {#asString. #first. #asOrderedCollection}.
	classes := {Character. String. Array}.
	didUnmodifiedAnswer := false.
	selectors withIndexDo: [:ansSel :ansInd | | do result ds answerMod | "Modify the answer object"
		answerMod := false.
		do := dataObjs copyTwoLevel.  ds := dataStrs copy.
		(dataObjs last isKindOf: (classes at: ansInd)) ifTrue: [
			((ansSel ~~ #first) or: [dataObjs last size = 1]) ifTrue: [
				do at: do size put: (do last perform: ansSel).	"asString"
				ds at: ds size put: ds last, ' ', ansSel.
				result := MethodFinder new load: do; findMessage.
				(result first beginsWith: 'no single method') ifFalse: [
					"found a selector!!"
					^ Array with: result first with: do with: ds].	
				answerMod := true]].

		selectors allButLast withIndexDo: [:argSel :argInd | | dds ddo | "Modify an argument object"
			"for args, no reason to do Array -> OrderedCollection.  Identical protocol."
			didUnmodifiedAnswer not | answerMod ifTrue: [
			ddo := do copyTwoLevel.  dds := ds copy.
			dataObjs first withIndexDo: [:arg :ind |
				(arg isKindOf: (classes at: argInd))  ifTrue: [
					((argSel ~~ #first) or: [arg size = 1]) ifTrue: [
						ddo first at: ind put: ((ddo first at: ind) perform: argSel).	"asString"
						dds at: ind put: (dds at: ind), ' ', argSel.
						result := MethodFinder new load: ddo; findMessage.
						(result first beginsWith: 'no single method') ifFalse: [
							"found a selector!!"
						^ Array with: result first with: ddo with: dds].	
					didUnmodifiedAnswer not & answerMod not ifTrue: [
						didUnmodifiedAnswer := true].
					]]]]].
	].
	^ Array with: 'no single method does that function' with: dataObjs with: dataStrs! !

!Finder methodsFor: 'initialize-release' stamp: 'sd 4/21/2011 15:52'!
uiClass
	"Answer the class used to create UI"
	 ^FinderUI! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:52'!
useRegEx
	"I should answer a boolean that tells whether regExpression should be taken into account"
	 ^ useRegEx! !

!Finder methodsFor: 'accessing' stamp: 'sd 4/21/2011 15:51'!
useRegEx: aBoolean

	useRegEx :=  aBoolean.! !

Object subclass: #MethodFinder
	instanceVariableNames: 'data answers selector argMap thisData mapStage mapList expressions cachedClass cachedArgNum cachedSelectorLists'
	classVariableNames: 'AddAndRemove Approved Blocks Dangerous'
	poolDictionaries: ''
	category: 'Finder-Core'!

!MethodFinder commentStamp: 'sd 4/21/2011 17:22' prior: 0!
Find a method in the system from a set of examples.  Done by brute force, trying every possible selector.  Errors are skipped over using ( [3 + 'xyz'] ifError: [^ false] ).
Submit an array of the form ((data1 data2) answer  (data1 data2) answer).

	MethodFinder methodFor: #( (4 3) 7  (0 5) 5  (5 5) 10).

answer:  'data1 + data2'

More generally, use the brace notation to construct live examples.

The program tries data1 as the receiver, and
	tries all other permutations of the data for the receiver and args, and
	tries leaving out one argument, and
	uses all selectors data understands, and
	uses all selectors in all od data's superclasses.

Floating point values must be precise to 0.01 percent, or (X * 0.0001).

If you get an error, you have probably discovered a selector that needs to be removed from the Approved list.  See MethodFinder.initialize.  Please email the Pharo Team.

Only considers 0, 1, 2, and 3 argument messages.  The argument data may have 1 to 5 entries, but only a max of 4 used at a time.  For now, we only test messages that use given number of args or one fewer.  For example, this data (100 true 0.6) would test the receiver plus two args, and the receiver plus one arg, but not any other patterns.

Three sets of selectors:  Approved, AddAndRemove, and Blocks selectors.  When testing a selector in AddAndRemove, deepCopy the receiver.  We do not handle selectors that modify an argument (printOn: etc.).  Blocks is a set of (selector argNumber) where that argument must be a block.

For perform, the selector is tested.  It must be in the Approved list.

do: is not on the Approved list.  It does not produce a result that can be tested.  Type 'do' into the upper pane of the Selector Finder to find messages list that.


Implementation Notes
	
	arguments of the load: method are structured as follows:
		- Odd list entries are data for it, even ones are the answers.  nil input means data and answers were supplied already."
		"(MethodFinder new) load: #( (4 3) 7  (-10 5) -5  (-3 11) 8)





!

!MethodFinder class methodsFor: 'instance creation' stamp: 'sd 4/21/2011 17:57'!
methodFor: dataAndAnswers
	"Return an expression that computes these answers."

	| resultOC resultString |
	resultOC := self new load: dataAndAnswers; findMessage.
	resultString := String streamContents: [:strm |
		resultOC do: [:exp | strm nextPut: $(; nextPutAll: exp; nextPut: $); space]].
	^ resultString! !

!MethodFinder methodsFor: 'find a constant' stamp: 'tk 12/29/2000 22:34'!
allNumbers
	"Return true if all answers and all data are numbers."

	answers do: [:aa | aa isNumber ifFalse: [^ false]].
	thisData do: [:vec |
			vec do: [:nn | nn isNumber ifFalse: [^ false]]].
	^ true! !

!MethodFinder methodsFor: 'accessing' stamp: 'tk 12/29/2000 13:39'!
answers

	^ answers! !

!MethodFinder methodsFor: 'argument permutation maps' stamp: 'tk 4/24/1999 19:29'!
argMap
	^ argMap ! !

!MethodFinder methodsFor: 'initialize' stamp: 'sd 4/21/2011 16:06'!
cleanInputs: dataAndAnswerString 
	"Find and remove common mistakes.  Complain when ill formed."
	| fixed ddd rs places |
	ddd := dataAndAnswerString.
	fixed := false.
	rs := (ddd , ' ') readStream.
	places := OrderedCollection new.
	
	[ rs upToAll: '#true'.
	rs atEnd ] whileFalse: [ places addFirst: rs position - 4 ].
	places do: 
		[ :pos | 
		ddd := ddd 
			copyReplaceFrom: pos
			to: pos
			with: ''.
		fixed := true ].	"remove #"
	rs := ddd readStream.
	places := OrderedCollection new.
	
	[ rs upToAll: '#false'.
	rs atEnd ] whileFalse: [ places addFirst: rs position - 5 ].
	places do: 
		[ :pos | 
		ddd := ddd 
			copyReplaceFrom: pos
			to: pos
			with: ''.
		fixed := true ].	"remove #"
	fixed ifTrue: 
		[ self inform: '#(true false) are Symbols, not Booleans.  
Next time use { true. false }.' ].
	fixed := false.
	rs := ddd readStream.
	places := OrderedCollection new.
	
	[ rs upToAll: '#nil'.
	rs atEnd ] whileFalse: [ places addFirst: rs position - 3 ].
	places do: 
		[ :pos | 
		ddd := ddd 
			copyReplaceFrom: pos
			to: pos
			with: ''.
		fixed := true ].	"remove #"
	fixed ifTrue: 
		[ self inform: '#nil is a Symbol, not the authentic UndefinedObject.  
Next time use nil instead of #nil' ].
	^ ddd! !

!MethodFinder methodsFor: 'find a constant' stamp: 'tk 1/18/2001 22:45'!
const
	| const |
	"See if (^ constant) is the answer"

	"quick test"
	((const := answers at: 1) closeTo: (answers at: 2)) ifFalse: [^ false].
	3 to: answers size do: [:ii | (const closeTo: (answers at: ii)) ifFalse: [^ false]].
	expressions add: '^ ', const printString.
	selector add: #yourself.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: 'tk 1/8/2001 17:49'!
constDiv
	| const subTest got |
	"See if (data1 // C) is the answer"

	const := ((thisData at: 1) at: 1) // (answers at: 1).  "May not be right!!"
	got := (subTest := MethodFinder new copy: self addArg: const) 
				searchForOne isEmpty not.
	got ifFalse: [^ false]. 

	"replace data2 with const in expressions"
	subTest expressions do: [:exp |
		expressions add: (exp copyReplaceAll: 'data2' with: const printString)].
	selector addAll: subTest selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: 'md 11/14/2003 16:47'!
constEquiv
	| const subTest got jj |
	"See if (data1 = C) or (data1 ~= C) is the answer"

	"quick test"
	((answers at: 1) class superclass == Boolean) ifFalse: [^ false].
	2 to: answers size do: [:ii | 
		((answers at: ii) class superclass == Boolean) ifFalse: [^ false]].

	const := (thisData at: 1) at: 1.
	got := (subTest := MethodFinder new copy: self addArg: const) 
				searchForOne isEmpty not.
	got ifFalse: ["try other polarity for ~~ "
		(jj := answers indexOf: (answers at: 1) not) > 0 ifTrue: [
		const := (thisData at: jj) at: 1.
		got := (subTest := MethodFinder new copy: self addArg: const) 
				searchForOne isEmpty not]]. 
	got ifFalse: [^ false]. 

	"replace data2 with const in expressions"
	subTest expressions do: [:exp |
		expressions add: (exp copyReplaceAll: 'data2' with: const printString)].
	selector addAll: subTest selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: 'tk 1/8/2001 17:47'!
constLinear
	| const subTest got denom num slope offset |
	"See if (data1 * C1) + C2 is the answer.  In the form  #(C2 C1) polynomialEval: data1 "

	denom := ((thisData at: 2) at: 1) - ((thisData at: 1) at: 1).
	denom = 0 ifTrue: [^ false].   "will divide by it"
	num := (answers at: 2) - (answers at: 1).

    slope := (num asFloat / denom) reduce.
    offset := ((answers at: 2) - (((thisData at: 2) at: 1) * slope)) reduce.

	const := Array with: offset with: slope.
	got := (subTest := MethodFinder new copy: self addArg: const) 
				searchForOne isEmpty not.
	got ifFalse: [^ false]. 

	"replace data2 with const in expressions"
	subTest expressions do: [:exp |
		expressions add: (exp copyReplaceAll: 'data2' with: const printString)].
	selector addAll: subTest selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: 'tk 1/18/2001 22:46'!
constMod
	| subTest low |
	"See if mod, (data1 \\ C) is the answer"

	low := answers max.
	low+1 to: low+20 do: [:const |
		subTest := MethodFinder new copy: self addArg: const.
		(subTest testPerfect: #\\) ifTrue: [
			expressions add: 'data1 \\ ', const printString.
			selector add: #\\.
			^ true]].
	^ false! !

!MethodFinder methodsFor: 'find a constant' stamp: 'tk 1/8/2001 17:49'!
constMult
	| const subTest got |
	"See if (data1 * C) is the answer"

	((thisData at: 1) at: 1) = 0 ifTrue: [^ false].
	const := ((answers at: 1) asFloat / ((thisData at: 1) at: 1)) reduce.
	got := (subTest := MethodFinder new copy: self addArg: const) 
				searchForOne isEmpty not.
	got ifFalse: [^ false]. 

	"replace data2 with const in expressions"
	subTest expressions do: [:exp |
		expressions add: (exp copyReplaceAll: 'data2' with: const printString)].
	selector addAll: subTest selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: 'tk 1/8/2001 17:48'!
constPlus
	| const subTest got |
	"See if (data1 + C) is the answer"

	const := (answers at: 1) - ((thisData at: 1) at: 1).
	got := (subTest := MethodFinder new copy: self addArg: const) 
				searchForOne isEmpty not.
	got ifFalse: [^ false]. 

	"replace data2 with const in expressions"
	subTest expressions do: [:exp |
		expressions add: (exp copyReplaceAll: 'data2' with: const printString)].
	selector addAll: subTest selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: 'nice 1/5/2010 15:59'!
constUsingData1Value
	| subTest |
	"See if (data1 <= C) or (data1 >= C) is the answer"

	"quick test"
	((answers at: 1) class superclass == Boolean) ifFalse: [^ false].
	2 to: answers size do: [:ii | 
		((answers at: ii) class superclass == Boolean) ifFalse: [^ false]].

	thisData do: [:datums | | const got | 
		const := datums first.	"use data as a constant!!"
		got := (subTest := MethodFinder new copy: self addArg: const) 
					searchForOne isEmpty not.
		got ifTrue: [
			"replace data2 with const in expressions"
			subTest expressions do: [:exp |
				expressions add: (exp copyReplaceAll: 'data2' with: const printString)].
			selector addAll: subTest selectors.
			^ true]].
	^ false! !

!MethodFinder methodsFor: 'initialize' stamp: 'sd 4/21/2011 16:06'!
copy: mthFinder addArg: aConstant
	"Copy inputs and answers, add an additional data argument to the inputs.  The same constant for every example"
	| more |
	more := Array with: aConstant.
	data := mthFinder data collect: [:argList | argList, more].
	answers := mthFinder answers.
	self load: nil.
! !

!MethodFinder methodsFor: 'accessing' stamp: 'tk 12/29/2000 13:39'!
data

	^ data! !

!MethodFinder methodsFor: 'accessing' stamp: 'tk 12/29/2000 13:20'!
expressions
	^ expressions! !

!MethodFinder methodsFor: 'public api' stamp: 'ar 4/10/2005 18:48'!
findMessage
	"Control the search."

	data do: [:alist |
		(alist isKindOf: SequenceableCollection) ifFalse: [
			^ OrderedCollection with: 'first and third items are not Arrays']].
	Approved ifNil: [self initialize].	"Sets of allowed selectors"
	expressions := OrderedCollection new.
	self search: true.	"multi"
	expressions isEmpty ifTrue: [^ OrderedCollection with: 'no single method does that function'].
	expressions isString ifTrue: [^ OrderedCollection with: expressions].
 	^ expressions! !

!MethodFinder methodsFor: 'search' stamp: 'sd 4/21/2011 17:51'!
handleExceptionalSelectors
	"Handle some very slippery selectors.
	asSymbol -- want to be able to produce it, but do not want to make every string submitted into a Symbol!!" 

	| aSel |
	answers first isSymbol ifFalse: [^ self].
	thisData first first isString ifFalse: [^ self].
	aSel := #asSymbol.
	(self testPerfect: aSel) ifTrue: [
		selector add: aSel.
		expressions add: (String streamContents: [:strm | 
			strm nextPutAll: 'data', argMap first printString.
			aSel keywords doWithIndex: [:key :ind |
				strm nextPutAll: ' ',key.
				(key last == $:) | (key first isLetter not)
					ifTrue: [strm nextPutAll: ' data', 
						(argMap at: ind+1) printString]]])].
! !

!MethodFinder methodsFor: 'initialize' stamp: 'MarcusDenker 7/3/2011 10:04'!
initialize
	"The methods we are allowed to use.  (MethodFinder new initialize) "
	super initialize.

	Approved := Set new.
	AddAndRemove := Set new.
	Blocks := Set new.
	"These modify an argument and are not used by the MethodFinder: longPrintOn: printOn: storeOn: sentTo: storeOn:base: printOn:base: absPrintExactlyOn:base: absPrintOn:base: absPrintOn:base:digitCount: writeOn: writeScanOn: possibleVariablesFor:continuedFrom: printOn:format:"


	"Initializing these variables all the time (especially since they contain statically declared information does not make a lot of sense - StephaneDucasse"

"Object"  
	#("in class, instance creation"  newFrom: 
"accessing" at: basicAt: basicSize in: size yourself 
"testing" ifNil: ifNil:ifNotNil: ifNotNil: ifNotNil:ifNil: isColor isFloat isFraction  isInteger isMorph isNil isNumber isPoint isPseudoContext isText isTransparent isWebBrowser notNil pointsTo: wantsSteps 
"comparing" = == closeTo: hash identityHash identityHashPrintString ~= ~~ 
"copying" copy shallowCopy 
"dependents access" canDiscardEdits dependents hasUnacceptedEdits 
"updating" changed changed: okToChange update: windowIsClosing 
"printing" fullPrintString isLiteral longPrintString printString storeString 
"class membership" class isKindOf: isMemberOf: respondsTo: xxxClass 
"error handling" 
"user interface" addModelMenuItemsTo:forMorph:hand: defaultBackgroundColor defaultLabelForInspector fullScreenSize initialExtent modelWakeUp mouseUpBalk:  windowActiveOnFirstClick windowReqNewLabel: 
"system primitives" instVarAt: instVarNamed: 
"private" 
"associating" -> 
"converting" as: asOrderedCollection asString 
"casing" caseOf: caseOf:otherwise: 
"binding" bindingOf: 
"macpal" contentsChanged currentEvent currentHand currentWorld flash instanceVariableValues  
"flagging" flag: 
"translation support" "objects from disk" "finalization" ) do: [:sel | Approved add: sel].
	#(at:add: at:modify: at:put: basicAt:put: "NOT instVar:at:"
"message handling" perform: perform:orSendTo: perform:with: perform:with:with: perform:with:with:with: perform:withArguments: perform:withArguments:inSuperclass: 
) do: [:sel | AddAndRemove add: sel].

"Boolean, True, False, UndefinedObject"  
	#("logical operations" & eqv: not xor: |
"controlling" and: ifFalse: ifFalse:ifTrue: ifTrue: ifTrue:ifFalse: or:
"copying" 
"testing" isEmptyOrNil) do: [:sel | Approved add: sel].

"Behavior" 
	#("initialize-release"
"accessing" compilerClass decompilerClass evaluatorClass format methodDict parserClass sourceCodeTemplate subclassDefinerClass
"testing" instSize instSpec isBits isBytes isFixed isPointers isVariable isWeak isWords
"copying"
"printing" printHierarchy
"creating class hierarchy"
"creating method dictionary"
"instance creation" basicNew basicNew: new new:
"accessing class hierarchy" allSubclasses allSubclassesWithLevelDo:startingLevel: allSuperclasses subclasses superclass withAllSubclasses withAllSuperclasses
"accessing method dictionary" allSelectors changeRecordsAt: compiledMethodAt: compiledMethodAt:ifAbsent: firstCommentAt: lookupSelector: selectors selectorsDo: selectorsWithArgs: "slow but useful ->" sourceCodeAt: sourceCodeAt:ifAbsent: sourceMethodAt: sourceMethodAt:ifAbsent:
"accessing instances and variables" allClassVarNames allInstVarNames allSharedPools classVarNames instVarNames instanceCount sharedPools someInstance subclassInstVarNames
"testing class hierarchy" inheritsFrom: kindOfSubclass
"testing method dictionary" canUnderstand: classThatUnderstands: hasMethods includesSelector: whichClassIncludesSelector: whichSelectorsAccess: whichSelectorsReferTo: whichSelectorsReferTo:special:byte: whichSelectorsStoreInto:
"enumerating"
"user interface"
"private" indexIfCompact) do: [:sel | Approved add: sel].

"ClassDescription"
	#("initialize-release" 
"accessing" classVersion isMeta name theNonMetaClass
"copying" 
"printing" classVariablesString instanceVariablesString sharedPoolsString
"instance variables" checkForInstVarsOK: 
"method dictionary" 
"organization" category organization whichCategoryIncludesSelector:
"compiling" acceptsLoggingOfCompilation wantsChangeSetLogging
"fileIn/Out" definition
"private" ) do: [:sel | Approved add: sel].

"Class"
	#("initialize-release" 
"accessing" classPool
"testing"
"copying" 
"class name" 
"instance variables" 
"class variables" classVarAt: classVariableAssociationAt:
"pool variables" 
"compiling" 
"subclass creation" 
"fileIn/Out" ) do: [:sel | Approved add: sel]. 

"Metaclass"
	#("initialize-release" 
"accessing" isSystemDefined soleInstance
"copying" "instance creation" "instance variables"  "pool variables" "class hierarchy"  "compiling"
"fileIn/Out"  nonTrivial ) do: [:sel | Approved add: sel].

"Context, BlockContext"
	#(receiver client method receiver tempAt: 
"debugger access" pc selector sender shortStack sourceCode tempNames tempsAndValues
"controlling"  "printing" "system simulation" 
"initialize-release" 
"accessing" hasMethodReturn home numArgs
"evaluating" value value:ifError: value:value: value:value:value: value:value:value:value: valueWithArguments:
"controlling"  "scheduling"  "instruction decoding"  "printing" "private"  "system simulation" ) do: [:sel | Approved add: sel].
	#(value: "<- Association has it as a store" ) do: [:sel | AddAndRemove add: sel].

"Message"
	#("inclass, instance creation" selector: selector:argument: selector:arguments:
"accessing" argument argument: arguments sends:
"printing" "sending" ) do: [:sel | Approved add: sel].
	#("private" setSelector:arguments:) do: [:sel | AddAndRemove add: sel].

"Magnitude"
	#("comparing" < <= > >= between:and:
"testing" max: min: min:max: ) do: [:sel | Approved add: sel].

"Date, Time"
	#("in class, instance creation" fromDays: fromSeconds: fromString: newDay:month:year: newDay:year: today
	"in class, general inquiries" dateAndTimeNow dayOfWeek: daysInMonth:forYear: daysInYear: firstWeekdayOfMonth:year: indexOfMonth: leapYear: nameOfDay: nameOfMonth:
"accessing" day leap monthIndex monthName weekday year
"arithmetic" addDays: subtractDate: subtractDays:
"comparing"
"inquiries" dayOfMonth daysInMonth daysInYear daysLeftInYear firstDayOfMonth previous:
"converting" asSeconds
"printing"  mmddyyyy printFormat: 
"private" weekdayIndex 
	"in class, instance creation" fromSeconds: now 
	"in class, general inquiries" dateAndTimeFromSeconds: dateAndTimeNow millisecondClockValue millisecondsToRun: totalSeconds
"accessing" hours minutes seconds
"arithmetic" addTime: subtractTime:
"comparing"
"printing" intervalString print24 
"converting") do: [:sel | Approved add: sel].
	#("private" 
		 ) do: [:sel | AddAndRemove add: sel].

"Number"
	#("in class" readFrom:base: 
"arithmetic" * + - / // \\ abs negated quo: reciprocal rem:
"mathematical functions" arcCos arcSin arcTan arcTan: cos exp floorLog: ln log log: raisedTo: raisedToInteger: sin sqrt squared tan
"truncation and round off" ceiling detentBy:atMultiplesOf:snap: floor roundTo: roundUpTo: rounded truncateTo: truncated
"comparing"
"testing" even isDivisibleBy: isInfinite isNaN isZero negative odd positive sign strictlyPositive
"converting" @ asInteger asNumber asPoint asSmallAngleDegrees degreesToRadians radiansToDegrees
"intervals" to: to:by: 
"printing" printStringBase: storeStringBase: ) do: [:sel | Approved add: sel].

"Integer"
	#("in class" primesUpTo:
"testing" isPowerOfTwo
"arithmetic" alignedTo:
"comparing"
"truncation and round off" atRandom normalize
"enumerating" timesRepeat:
"mathematical functions" degreeCos degreeSin factorial gcd: lcm: take:
"bit manipulation" << >> allMask: anyMask: bitAnd: bitClear: bitInvert bitInvert32 bitOr: bitShift: bitXor: lowBit noMask:
"converting" asCharacter asColorOfDepth: asFloat asFraction asHexDigit
"printing" asStringWithCommas hex hex8 radix:
"system primitives" lastDigit replaceFrom:to:with:startingAt:
"private" "benchmarks" ) do: [:sel | Approved add: sel].

"SmallInteger, LargeNegativeInteger, LargePositiveInteger"
	#("arithmetic" "bit manipulation" highBit "testing" "comparing" "copying" "converting" "printing" 
"system primitives" digitAt: digitLength 
"private" fromString:radix: ) do: [:sel | Approved add: sel].
	#(digitAt:put: ) do: [:sel | AddAndRemove add: sel].

"Float"
	#("arithmetic"
"mathematical functions" reciprocalFloorLog: reciprocalLogBase2 timesTwoPower:
"comparing" "testing"
"truncation and round off" exponent fractionPart integerPart significand significandAsInteger
"converting" asApproximateFraction asIEEE32BitWord asTrueFraction
"copying") do: [:sel | Approved add: sel].

"Fraction, Random"
	#(denominator numerator reduced next nextValue) do: [:sel | Approved add: sel].
	#(setNumerator:denominator:) do: [:sel | AddAndRemove add: sel].

"Collection"
	#("accessing" anyOne
"testing" includes: includesAllOf: includesAnyOf: includesSubstringAnywhere: isEmpty isSequenceable occurrencesOf:
"enumerating" collect: collect:thenSelect: count: detect: detect:ifNone: detectMax: detectMin: detectSum: inject:into: reject: select: select:thenCollect: intersection:
"converting" asBag asCharacterSet asSet  asSortedCollection asSortedCollection:
"printing"
"private" maxSize
"arithmetic"
"math functions" average max median min range sum) do: [:sel | Approved add: sel].
	#("adding" add: addAll: addIfNotPresent:
"removing" remove: remove:ifAbsent: removeAll: removeAllFoundIn: removeAllSuchThat: remove:ifAbsent:) do: [:sel | AddAndRemove add: sel].

"SequenceableCollection"
	#("comparing" hasEqualElements:
"accessing" allButFirst allButLast at:ifAbsent: atAll: atPin: atRandom: atWrap: fifth first first: fourth identityIndexOf: identityIndexOf:ifAbsent: indexOf: indexOf:ifAbsent: indexOf:startingAt:ifAbsent: indexOfSubCollection:startingAt: indexOfSubCollection:startingAt:ifAbsent: last second sixth third
"removing"
"copying" , copyAfterLast: copyAt:put: copyFrom:to: copyReplaceAll:with: copyReplaceFrom:to:with: copyUpTo: copyUpToLast: copyWith: copyWithout: copyWithoutAll: forceTo:paddingWith: shuffled sort:
"enumerating" collectWithIndex: findFirst: findLast: pairsCollect: with:collect: withIndexCollect: polynomialEval:
"converting" asArray asDictionary asFloatArray asIntegerArray asStringWithCr asWordArray reversed
"private" copyReplaceAll:with:asTokens: ) do: [:sel | Approved add: sel].
	#( swap:with:) do: [:sel | AddAndRemove add: sel].

"ArrayedCollection, Bag"
	#("private" defaultElement 
"sorting" isSorted
"accessing" cumulativeCounts sortedCounts sortedElements "testing" "adding" add:withOccurrences: "removing" "enumerating" 
	) do: [:sel | Approved add: sel].
	#( mergeSortFrom:to:by: sort sort: add: add:withOccurrences:
"private" setDictionary ) do: [:sel | AddAndRemove add: sel].

"Other messages that modify the receiver"
	#(atAll:put: atAll:putAll: atAllPut: atWrap:put: replaceAll:with: replaceFrom:to:with:  removeFirst removeLast) do: [:sel | AddAndRemove add: sel].

	self initialize2.

"
MethodFinder new initialize.
MethodFinder new organizationFiltered: Set
"

! !

!MethodFinder methodsFor: 'initialize' stamp: 'FernandoOlivero 3/30/2011 14:46'!
initialize2
	"The methods we are allowed to use.  (MethodFinder new initialize) "

"Set"
	#("in class" sizeFor:
"testing" "adding" "removing" "enumerating"
"private" array findElementOrNil: 
"accessing" someElement) do: [:sel | Approved add: sel].

"Dictionary, IdentityDictionary, IdentitySet"
	#("accessing" associationAt: associationAt:ifAbsent: at:ifPresent: keyAtIdentityValue: keyAtIdentityValue:ifAbsent: keyAtValue: keyAtValue:ifAbsent: keys
"testing" includesKey: ) do: [:sel | Approved add: sel].
	#(removeKey: removeKey:ifAbsent:
) do: [:sel | AddAndRemove add: sel].

"LinkedList, Interval, MappedCollection"
	#("in class"  from:to: from:to:by:
"accessing" contents) do: [:sel | Approved add: sel].
	#(
"adding" addFirst: addLast:) do: [:sel | AddAndRemove add: sel].

"OrderedCollection, SortedCollection"
	#("accessing" after: before:
"copying" copyEmpty
"adding"  growSize
"removing" "enumerating" "private" 
"accessing" sortBlock) do: [:sel | Approved add: sel].
	#("adding" add:after: add:afterIndex: add:before: addAllFirst: addAllLast: addFirst: addLast:
"removing" removeAt: removeFirst removeLast
"accessing" sortBlock:) do: [:sel | AddAndRemove add: sel].

"Character"
	#("in class, instance creation" allCharacters digitValue: new separators
	"accessing untypeable characters" backspace cr enter lf linefeed nbsp newPage space tab
	"constants" alphabet characterTable
"accessing" asciiValue digitValue
"comparing"
"testing" isAlphaNumeric isDigit isLetter isLowercase isSafeForHTTP isSeparator isSpecial isUppercase isVowel tokenish
"copying"
"converting" asLowercase asUppercase
	) do: [:sel | Approved add: sel].

"String"
	#("in class, instance creation" crlf fromPacked:
	"primitives" findFirstInString:inSet:startingAt: indexOfAscii:inString:startingAt: 	"internet"
"accessing" byteAt: endsWithDigit findAnySubStr:startingAt: findBetweenSubStrs: findDelimiters:startingAt: findString:startingAt: findString:startingAt:caseSensitive: findTokens: findTokens:includes: findTokens:keep: includesSubString: includesSubstring:caseSensitive: indexOf:startingAt: indexOfAnyOf: indexOfAnyOf:ifAbsent: indexOfAnyOf:startingAt: indexOfAnyOf:startingAt:ifAbsent: lineCorrespondingToIndex: lineCount lineNumber: skipAnySubStr:startingAt: skipDelimiters:startingAt: startsWithDigit
"comparing" alike: beginsWith: caseSensitiveLessOrEqual: charactersExactlyMatching: compare: crc16 endsWith: endsWithAnyOf: sameAs: startingAt:match:startingAt:
"copying" copyReplaceTokens:with: padded:to:with:
"converting" asByteArray asDate asFileName asLegalSelector asPacked asText asTime asUrl asUrlRelativeTo: capitalized compressWithTable: contractTo: correctAgainst: encodeForHTTP initialIntegerOrNil keywords quoted withoutPeriodSuffix splitInteger stemAndNumericSuffix substrings surroundedBySingleQuotes truncateWithElipsisTo: withBlanksTrimmed withFirstCharacterDownshifted withNoLineLongerThan: withSeparatorsCompacted withoutLeadingDigits withoutTrailingBlanks
"displaying" "printing"
"system primitives" compare:with:collated: 
"Celeste" withCRs
"internet" decodeMimeHeader decodeQuotedPrintable unescapePercents withInternetLineEndings withSqueakLineEndings withoutQuoting
"testing" isAllSeparators lastSpacePosition
"paragraph support" indentationIfBlank:
"arithmetic" ) do: [:sel | Approved add: sel].
	#(byteAt:put: translateToLowercase match:) do: [:sel | AddAndRemove add: sel].

"Symbol"
	#("in class, private" hasInterned:ifTrue:
	"access" morePossibleSelectorsFor: possibleSelectorsFor: selectorsContaining: thatStarts:skipping:
"accessing" "comparing" "copying" "converting" "printing" 
"testing" isInfix isKeyword isUnary) do: [:sel | Approved add: sel].

"Array"
	#("comparing" "converting" 
"printing" "private" hasLiteralSuchThat:) do: [:sel | Approved add: sel].

"Array2D"
	#("access" at:at: atCol: atCol:put: atRow: extent extent:fromArray: height width width:height:type:) do: [:sel | Approved add: sel].
	#(at:at:add: at:at:put: atRow:put: ) do: [:sel | AddAndRemove add: sel].

"ByteArray"
	#("accessing" doubleWordAt: wordAt: 
"platform independent access" longAt:bigEndian: shortAt:bigEndian: unsignedLongAt:bigEndian: unsignedShortAt:bigEndian: 
"converting") do: [:sel | Approved add: sel].
	#(doubleWordAt:put: wordAt:put: longAt:put:bigEndian: shortAt:put:bigEndian: unsignedLongAt:put:bigEndian: unsignedShortAt:put:bigEndian:
	) do: [:sel | AddAndRemove add: sel].

"FloatArray"		"Dont know what happens when prims not here"
	false ifTrue: [#("accessing" "arithmetic" *= += -= /=
"comparing"
"primitives-plugin" primAddArray: primAddScalar: primDivArray: primDivScalar: primMulArray: primMulScalar: primSubArray: primSubScalar:
"primitives-translated" primAddArray:withArray:from:to: primMulArray:withArray:from:to: primSubArray:withArray:from:to:
"converting" "private" "user interface") do: [:sel | Approved add: sel].
	].

"IntegerArray, WordArray"
"RunArray"
	#("in class, instance creation" runs:values: scanFrom:
"accessing" runLengthAt: 
"adding" "copying"
"private" runs values) do: [:sel | Approved add: sel].
	#(coalesce addLast:times: repeatLast:ifEmpty: repeatLastIfEmpty:
		) do: [:sel | AddAndRemove add: sel].

"Stream  -- many operations change its state"
	#("testing" atEnd) do: [:sel | Approved add: sel].
	#("accessing" next: nextMatchAll: nextMatchFor: upToEnd
next:put: nextPut: nextPutAll: "printing" print:
	) do: [:sel | AddAndRemove add: sel].

"PositionableStream"
	#("accessing" contentsOfEntireFile originalContents peek peekFor: "testing"
"positioning" position ) do: [:sel | Approved add: sel].
	#(nextDelimited: nextLine upTo: position: reset resetContents setToEnd skip: skipTo: upToAll: ) do: [:sel | AddAndRemove add: sel].
	"Because it is so difficult to test the result of an operation on a Stream (you have to supply another Stream in the same state), we don't support Streams beyond the basics.  We want to find the messages that convert Streams to other things."

"ReadWriteStream"
	#("file status" closed) do: [:sel | Approved add: sel].
	#("accessing" next: on: ) do: [:sel | AddAndRemove add: sel].

"WriteStream"
	#("in class, instance creation" on:from:to: with: with:from:to:
		) do: [:sel | Approved add: sel].
	#("positioning" resetToStart
"character writing" crtab crtab:) do: [:sel | AddAndRemove add: sel].

"LookupKey, Association, Link"
	#("accessing" key nextLink) do: [:sel | Approved add: sel].
	#(key: key:value: nextLink:) do: [:sel | AddAndRemove add: sel].

"Point"
	#("in class, instance creation" r:degrees: x:y:
"accessing" x y "comparing" "arithmetic" "truncation and round off"
"polar coordinates" degrees r theta
"point functions" bearingToPoint: crossProduct: dist: dotProduct: eightNeighbors flipBy:centerAt: fourNeighbors grid: nearestPointAlongLineFrom:to: nearestPointOnLineFrom:to: normal normalized octantOf: onLineFrom:to: onLineFrom:to:within: quadrantOf: rotateBy:centerAt: transposed unitVector
"converting" asFloatPoint asIntegerPoint corner: extent: rect:
"transforming" adhereTo: rotateBy:about: scaleBy: scaleFrom:to: translateBy: "copying"
"interpolating" interpolateTo:at:) do: [:sel | Approved add: sel].

"Rectangle"
	#("in class, instance creation" center:extent: encompassing: left:right:top:bottom: 
	merging: origin:corner: origin:extent: 
"accessing" area bottom bottomCenter bottomLeft bottomRight boundingBox center corner corners innerCorners left leftCenter origin right rightCenter top topCenter topLeft topRight
"comparing"
"rectangle functions" adjustTo:along: amountToTranslateWithin: areasOutside: bordersOn:along: encompass: expandBy: extendBy: forPoint:closestSideDistLen: insetBy: insetOriginBy:cornerBy: intersect: merge: pointNearestTo: quickMerge: rectanglesAt:height: sideNearestTo: translatedToBeWithin: withBottom: withHeight: withLeft: withRight: withSide:setTo: withTop: withWidth:
"testing" containsPoint: containsRect: hasPositiveExtent intersects: isTall isWide
"truncation and round off"
"transforming" align:with: centeredBeneath: newRectFrom: squishedWithin: "copying"
	) do: [:sel | Approved add: sel].

"Color"
	#("in class, instance creation" colorFrom: colorFromPixelValue:depth: fromRgbTriplet: gray: h:s:v: r:g:b: r:g:b:alpha: r:g:b:range:
	"named colors" black blue brown cyan darkGray gray green lightBlue lightBrown lightCyan lightGray lightGreen lightMagenta lightOrange lightRed lightYellow magenta orange red transparent veryDarkGray veryLightGray veryVeryDarkGray veryVeryLightGray white yellow
	"other" colorNames indexedColors pixelScreenForDepth: quickHighLight:
"access" alpha blue brightness green hue luminance red saturation
"equality"
"queries" isBitmapFill isBlack isGray isSolidFill isTranslucent isTranslucentColor
"transformations" alpha: dansDarker darker lighter mixed:with: muchLighter slightlyDarker slightlyLighter veryMuchLighter alphaMixed:with:
"groups of shades" darkShades: lightShades: mix:shades: wheel:
"printing" shortPrintString
"other" colorForInsets rgbTriplet
"conversions" asB3DColor asColor balancedPatternForDepth: bitPatternForDepth: closestPixelValue1 closestPixelValue2 closestPixelValue4 closestPixelValue8 dominantColor halfTonePattern1 halfTonePattern2 indexInMap: pixelValueForDepth: pixelWordFor:filledWith: pixelWordForDepth: scaledPixelValue32
"private" privateAlpha privateBlue privateGreen privateRGB privateRed "copying"
	) do: [:sel | Approved add: sel].

"	For each selector that requires a block argument, add (selector argNum) 
		to the set Blocks."
"ourClasses := #(Object Boolean True False UndefinedObject Behavior ClassDescription Class Metaclass MethodContext BlockContext Message Magnitude Date Time Number Integer SmallInteger LargeNegativeInteger LargePositiveInteger Float Fraction Random Collection SequenceableCollection ArrayedCollection Bag Set Dictionary IdentityDictionary IdentitySet LinkedList Interval MappedCollection OrderedCollection SortedCollection Character String Symbol Array Array2D ByteArray FloatArray IntegerArray WordArray RunArray Stream PositionableStream ReadWriteStream WriteStream LookupKey Association Link Point Rectangle Color).
ourClasses do: [:clsName | cls := Smalltalk at: clsName.
	(cls selectors) do: [:aSel |
		((Approved includes: aSel) or: [AddAndRemove includes: aSel]) ifTrue: [
			(cls formalParametersAt: aSel) withIndexDo: [:tName :ind |
				(tName endsWith: 'Block') ifTrue: [
					Blocks add: (Array with: aSel with: ind)]]]]].
"
#((timesRepeat: 1 ) (indexOf:ifAbsent: 2 ) (pairsCollect: 1 ) (mergeSortFrom:to:by: 3 ) (ifNotNil:ifNil: 1 ) (ifNotNil:ifNil: 2 ) (ifNil: 1 ) (at:ifAbsent: 2 ) (ifNil:ifNotNil: 1 ) (ifNil:ifNotNil: 2 ) (ifNotNil: 1 ) (at:modify: 2 ) (identityIndexOf:ifAbsent: 2 ) (sort: 1 ) (sortBlock: 1 ) (detectMax: 1 ) (repeatLastIfEmpty: 1 ) (allSubclassesWithLevelDo:startingLevel: 1 ) (keyAtValue:ifAbsent: 2 ) (in: 1 ) (ifTrue: 1 ) (or: 1 ) (select: 1 ) (inject:into: 2 )  (forPoint:closestSideDistLen: 2 ) (value:ifError: 2 ) (selectorsDo: 1 ) (removeAllSuchThat: 1 ) (keyAtIdentityValue:ifAbsent: 2 ) (detectMin: 1 ) (detect:ifNone: 1 ) (ifTrue:ifFalse: 1 ) (ifTrue:ifFalse: 2 ) (detect:ifNone: 2 ) (hasLiteralSuchThat: 1 ) (indexOfAnyOf:ifAbsent: 2 ) (reject: 1 ) (newRectFrom: 1 ) (removeKey:ifAbsent: 2 ) (at:ifPresent: 2 ) (associationAt:ifAbsent: 2 ) (withIndexCollect: 1 ) (repeatLast:ifEmpty: 2 ) (findLast: 1 ) (indexOf:startingAt:ifAbsent: 3 ) (remove:ifAbsent: 2 ) (ifFalse:ifTrue: 1 ) (ifFalse:ifTrue: 2 ) (caseOf:otherwise: 2 ) (count: 1 ) (collect: 1 ) (sort: 1 ) (and: 1 ) (asSortedCollection: 1 ) (with:collect: 2 ) (sourceCodeAt:ifAbsent: 2 ) (detect: 1 ) (collectWithIndex: 1 ) (compiledMethodAt:ifAbsent: 2 ) (detectSum: 1 ) (indexOfSubCollection:startingAt:ifAbsent: 3 ) (findFirst: 1 ) (sourceMethodAt:ifAbsent: 2 ) (collect:thenSelect: 1 ) (collect:thenSelect: 2 ) (select:thenCollect: 1 ) (select:thenCollect: 2 ) (ifFalse: 1 ) (indexOfAnyOf:startingAt:ifAbsent: 3 ) (indentationIfBlank: 1 ) ) do: [:anArray |
	Blocks add: anArray].

self initialize3.

"
MethodFinder new initialize.
MethodFinder new organizationFiltered: TranslucentColor class 
"
"Do not forget class messages for each of these classes"
! !

!MethodFinder methodsFor: 'initialize' stamp: 'sd 4/21/2011 17:10'!
initialize3
	"additional selectors to consider"

	#(asWords threeDigitName ) do: [:sel | Approved add: sel].! !

!MethodFinder methodsFor: 'search' stamp: 'tk 4/12/2001 10:47'!
insertConstants
	"see if one of several known expressions will do it. C is the constant we discover here."
	"C  data1+C  data1*C  data1//C  (data1*C1 + C2) (data1 = C) (data1 ~= C) (data1 <= C) (data1 >= C) 
 (data1 mod C)"

	thisData size >= 2 ifFalse: [^ false].	"need 2 examples"
	(thisData at: 1) size = 1 ifFalse: [^ false].	"only one arg, data1"

	self const ifTrue: [^ true].
	self constUsingData1Value ifTrue: [^ true].
		"(data1 ?? const), where const is one of the values of data1"
		" == ~~ ~= = <= >= "

	self allNumbers ifFalse: [^ false].
	self constMod ifTrue: [^ true].
	self constPlus ifTrue: [^ true].
	self constMult ifTrue: [^ true].
	self constDiv ifTrue: [^ true].
	self constLinear ifTrue: [^ true].
	^ false! !

!MethodFinder methodsFor: 'public api' stamp: 'sd 4/21/2011 17:33'!
load: dataWithAnswers
	"Find a function that takes the data and gives the answers.  Odd list entries are data for it, even ones are the answers.  nil input means data and answers were supplied already."
	"(MethodFinder new) load: #( (4 3) 7  (-10 5) -5  (-3 11) 8);
		findMessage  "

	dataWithAnswers ifNotNil: [
		data := Array new: dataWithAnswers size // 2.
		1 to: data size do: [:ii | data at: ii put: (dataWithAnswers at: ii*2-1)].
		answers := Array new: data size.
		1 to: answers size do: [:ii | answers at: ii put: (dataWithAnswers at: ii*2)]].
	data do: [:list | 
		(list isKindOf: SequenceableCollection) ifFalse: [
			^ self error: 'first and third items are not Arrays'].
		].
	argMap := (1 to: data first size) asArray.
	data do: [:list | list size = argMap size ifFalse: [
			self error: 'data arrays must all be the same size']].
	argMap size > 4 ifTrue: [self error: 'No more than a receiver and 
		three arguments allowed'].
		
	thisData := data copy.
	mapStage := mapList := nil.
! !

!MethodFinder methodsFor: 'argument permutation maps' stamp: 'tk 5/18/1999 14:46'!
makeAllMaps 
	"Make a giant list of all permutations of the args.  To find the function, we will try these permutations of the input data.  receiver, args."

	| ii |
	mapList := Array new: argMap size factorial.
	ii := 1.
	argMap permutationsDo: [:perm |
		mapList at: ii put: perm copy.
		ii := ii + 1].
	mapStage := 1.	"about to be bumped"! !

!MethodFinder methodsFor: 'argument permutation maps' stamp: 'sd 4/21/2011 17:01'!
mapData 
	"Force the data through the map (permutation) to create the data to test."

	thisData := data collect: [:realData | argMap collect: [:ind | realData at: ind]].
		! !

!MethodFinder methodsFor: 'argument permutation maps' stamp: 'tk 5/24/1999 16:31'!
permuteArgs 
	"Run through ALL the permutations.  First one was as presented."

	data first size <= 1 ifTrue: [^ false].	"no other way"
	mapList ifNil: [self makeAllMaps].
	mapStage := mapStage + 1.
	mapStage > mapList size ifTrue: [^ false].
	argMap := mapList at: mapStage.
	self mapData.
	^ true
	! !

!MethodFinder methodsFor: 'public api' stamp: 'sd 4/21/2011 17:48'!
search: multi
	"if Multi is true, collect all selectors that work."
	selector := OrderedCollection new.	"list of them"
	self simpleSearch.
	multi not & (selector isEmpty not) ifTrue: [^ selector].

	[self permuteArgs] whileTrue:
		[self simpleSearch.
		multi not & (selector isEmpty not) ifTrue: [^ selector]].
	self insertConstants.
	^ #()! !

!MethodFinder methodsFor: 'search' stamp: 'tk 1/8/2001 17:53'!
searchForOne
	"Look for and return just one answer"

	expressions := OrderedCollection new.
	self search: false.	"non-multi"
	^ expressions
			! !

!MethodFinder methodsFor: 'accessing' stamp: 'tk 1/4/2001 17:18'!
selectors
	"Note the inst var does not have an S on the end"

	^ selector! !

!MethodFinder methodsFor: 'search' stamp: 'sd 4/21/2011 17:51'!
simpleSearch
	"Run through first arg's class' selectors, looking for one that works."

	| class supers listOfLists |
	self handleExceptionalSelectors.
	class := thisData first first class.
	"Cache the selectors for the receiver class"
	(class == cachedClass and: [cachedArgNum = ((argMap size) - 1)]) 
		ifTrue: [listOfLists := cachedSelectorLists]
		ifFalse: [
			supers := class withAllSuperclasses.
			listOfLists := OrderedCollection new.
			supers do: [:cls |
				listOfLists add: (cls selectorsWithArgs: (argMap size) - 1)].
			cachedClass := class.
			cachedArgNum := (argMap size) - 1.
			cachedSelectorLists := listOfLists].
	listOfLists do: [:selectorList |
		selectorList do: [:aSel |
			(selector includes: aSel) ifFalse: [
				((Approved includes: aSel) or: [AddAndRemove includes: aSel]) ifTrue: [
					(self testPerfect: aSel) ifTrue: [
						selector add: aSel.
						expressions add: (String streamContents: [:strm | 
							strm nextPutAll: 'data', argMap first printString.
							aSel keywords doWithIndex: [:key :ind |
								strm nextPutAll: ' ',key.
								(key last == $:) | (key first isLetter not)
									ifTrue: [strm nextPutAll: ' data', 
										(argMap at: ind+1) printString]]])
						]]]]].
! !

!MethodFinder methodsFor: 'debugging it' stamp: 'ar 4/10/2005 18:48'!
test2: anArray
	"look for bad association"

	anArray do: [:sub |
		sub class == Association ifTrue: [
			(#('true' '$a' '2' 'false') includes: sub value printString) ifFalse: [
				self error: 'bad assn'].
			(#('3' '5.6' 'x' '''abcd''') includes: sub key printString) ifFalse: [
				self error: 'bad assn'].
		].
		sub class == Array ifTrue: [
			sub do: [:element | 
				element isString ifTrue: [element first asciiValue < 32 ifTrue: [
						self error: 'store into string in data']].
				element class == Association ifTrue: [
					element value class == Association ifTrue: [
						self error: 'bad assn']]]].
		sub class == Date ifTrue: [sub year isInteger ifFalse: [
				self error: 'stored into input date!!!!']].
		sub class == Dictionary ifTrue: [
				sub size > 0 ifTrue: [
					self error: 'store into dictionary']].
		sub class == OrderedCollection ifTrue: [
				sub size > 4 ifTrue: [
					self error: 'store into OC']].
		].! !

!MethodFinder methodsFor: 'tests' stamp: 'sd 4/21/2011 16:58'!
testFromTuple: nth
	"verify that the methods allowed don't crash the system.  Try N of each of the fundamental types.  up to 4 of each kind." 

	| objects nonRepeating even other aa cnt |
	objects := #((1 4 17 42) ($a $b $c $d) ('one' 'two' 'three' 'four')
	(x + rect: new) ((a b 1 4) (c 1 5) ($a 3 d) ()) (4.5 0.0 3.2 100.3)
	).

	objects := objects, {{true. false. true. false}. {Point. SmallInteger. Association. Array}.
	{Point class. SmallInteger class. Association class. Array class}.
	"{ 4 blocks }."
	{Date today. '1 Jan 1950' asDate. '25 Aug 1987' asDate. '1 Jan 2000' asDate}.
	{'15:16' asTime. '1:56' asTime. '4:01' asTime. '6:23' asTime}.
	{Dictionary new. Dictionary new. Dictionary new. Dictionary new}.
	{#(a b 1 4) asOrderedCollection. #(c 1 5) asOrderedCollection. 
		#($a 3 d) asOrderedCollection. #() asOrderedCollection}.
	{3->true. 5.6->$a. #x->2. 'abcd'->false}.
	{9 @ 3 extent: 5 @ 4. 0 @ 0 extent: 45 @ 9. -3 @ -7 extent: 2 @ 2. 4 @ 4 extent: 16 @ 16}.
	{Color red.  Color blue. Color black. Color gray}}.

	self test2: objects.
	"rec+0, rec+1, rec+2, rec+3 need to be tested.  " 
	cnt := 0.
	nth to: 4 do: [:take |
		nonRepeating := OrderedCollection new.
		objects do: [:each |
			nonRepeating addAll: (each copyFrom: 1 to: take)].
		"all combinations of take, from nonRepeating"
		even := true.
		nonRepeating combinations: take atATimeDo: [:tuple |
			even ifTrue: [other := tuple shallowCopy]
				ifFalse: [self load: (aa := Array with: tuple with: 1 with: other with: 7).
					(cnt := cnt+1) \\ 50 = 0 ifTrue: [
						Transcript cr; show: aa first printString].
					self search: true.
					self test2: aa.
					self test2: nonRepeating.
					"self test2: objects"].
			even := even not].
		].! !

!MethodFinder methodsFor: 'search' stamp: 'sd 4/21/2011 17:09'!
testPerfect: aSelector
	"Try this selector!! Return true if it answers every example perfectly.  Take the args in the order they are.  Do not permute them.  Survive errors.  later cache arg lists."

	| sz argList val rec activeSel perform |

	perform := aSelector beginsWith: 'perform:'.
	sz := argMap size.
	1 to: thisData size do: [:ii | "each example set of args"
		argList := (thisData at: ii) copyFrom: 2 to: sz.
		perform
			ifFalse: [activeSel := aSelector]
			ifTrue: [activeSel := argList first.	"what will be performed"
				((Approved includes: activeSel) or: [AddAndRemove includes: activeSel])
					ifFalse: [^ false].	"not approved"
				aSelector == #perform:withArguments: 
					ifTrue: [activeSel numArgs = (argList at: 2) basicSize "avoid error" 
								ifFalse: [^ false]]
					ifFalse: [activeSel numArgs = (aSelector numArgs - 1) 
								ifFalse: [^ false]]].
		1 to: sz do: [:num | 
			(Blocks includes: (Array with: activeSel with: num)) ifTrue: [
				(argList at: num) isBlock ifFalse: [^ false]]].
		rec := (AddAndRemove includes: activeSel) 
				ifTrue: [(thisData at: ii) first isSymbol ifTrue: [^ false].
						"vulnerable to modification"
					(thisData at: ii) first copyTwoLevel] 	"protect from damage"
				ifFalse: [(thisData at: ii) first].
		val := [[rec perform: aSelector withArguments: argList] 
					ifError: [:aString :aReceiver | 
							^ false]] on: Deprecation do: [:depr | 
							"We do not want to list deprecated methods" 
							^false.].
		((answers at: ii) closeTo: val) ifFalse: [^ false].
		].
	^ true! !

!MethodFinder methodsFor: 'debugging it' stamp: 'sd 4/21/2011 15:35'!
testRandom
	"verify that the methods allowed don't crash the system.  Pick 3 or 4 from a mixed list of the fundamental types."
	"MethodFinder new testRandom"
	
	| objects other aa cnt take tuple fName sss |
	objects := #(#(1 4 17 42) #($a $b $c $d) #('one' 'two' 'three' 'four') #(#x #+ #rect: #new) #(#(#a #b 1 4) #(#c 1 5) #($a 3 #d) #()) #(4.5 0.0 3.2 100.3)).
	objects := objects
		,
			{{true.
			false.
			true.
			false}.
			{Point.
			SmallInteger.
			Association.
			Array}.
			{"{ 4 blocks }."
			(Point class).
			(SmallInteger class).
			(Association class).
			(Array class)}.	"{ 4 blocks }."
			{(Date today).
			('1 Jan 1950' asDate).
			('25 Aug 1987' asDate).
			('1 Jan 2000' asDate)}.
			{('15:16' asTime).
			('1:56' asTime).
			('4:01' asTime).
			('6:23' asTime)}.
			{(Dictionary new).
			(Dictionary new).
			(Dictionary new).
			(Dictionary new)}.
			{(#(#a #b 1 4) asOrderedCollection).
			(#(#c 1 5) asOrderedCollection).
			(#($a 3 #d) asOrderedCollection).
			(#() asOrderedCollection)}.
			{(3 -> true).
			(5.6 -> $a).
			(#x -> 2).
			('abcd' -> false)}.
			{(9 @ 3 extent: 5 @ 4).
			(0 @ 0 extent: 45 @ 9).
			(-3 @ -7 extent: 2 @ 2).
			(4 @ 4 extent: 16 @ 16)}.
			{(Color red).
			(Color blue).
			(Color black).
			(Color gray)}}.
	self test2: objects.	"rec+0, rec+1, rec+2, rec+3 need to be tested.  "
	fName := (FileDirectory default fileNamesMatching: '*.ran') first.
	sss := fName splitInteger first.
	(Collection classPool at: #RandomForPicking) seed: sss.
	cnt := 0.
	[ 
	take := #(3 4) atRandom.
	tuple := (1 to: take) collect: [ :ind | objects atRandom atRandom ].
	other := (1 to: take) collect: [ :ind | objects atRandom atRandom ].
	self
		load:
			(aa := Array
				with: tuple
				with: 1
				with: other
				with: 7).
	(cnt := cnt + 1) \\ 10 = 0
		ifTrue: [ 
			Transcript
				cr;
				show: cnt printString;
				tab;
				tab;
				show: aa first printString ].	" | (cnt > Skip)"
	cnt > (Smalltalk globals at: #StopHere)
		ifTrue: [ self halt ].	"stop just before crash"
	cnt > (Smalltalk globals at: #Skip)
		ifTrue: [ 
			"skip this many at start"
			self search: true.
			self test2: aa first.
			self test2: (aa at: 3)	"self test2: objects" ].
	true ] whileTrue! !

!MethodFinder methodsFor: 'argument permutation maps' stamp: 'tk 4/24/1999 19:29'!
thisData
	^ thisData ! !

!MethodFinder methodsFor: 'tests' stamp: 'sd 4/21/2011 16:58'!
verify
	"Test a bunch of examples"
	"	MethodFinder new verify    "
	Approved ifNil: [self initialize].	"Sets of allowed selectors"

(MethodFinder new load: #(('abcd') $a  ('TedK') $T)
	) searchForOne asArray = #('data1 asCharacter' 'data1 first' 'data1 anyOne')
		 ifFalse: [self error: 'should have found it'].	
(MethodFinder new load: #(('abcd' 1) $a  ('Ted ' 3) $d )
	) searchForOne asArray = #('data1 at: data2' 'data1 atPin: data2' 'data1 atWrap: data2')
		ifFalse: [self error: 'should have found it'].	
(MethodFinder new load: #(((12 4 8)) 24  ((1 3 6)) 10 )
	) searchForOne asArray=  #('data1 sum') ifFalse: [self error: 'should have found it'].	
		"note extra () needed for an Array object as an argument"


(MethodFinder new load: #((4) 4  (-10) 10 (-3) 3 (2) 2 (-6) 6 (612) 612)
	) searchForOne asArray = #('data1 abs') ifFalse: [self error: 'should have found it'].
(MethodFinder new load: {#(4 3). true.  #(-7 3). false.  #(5 1). true.  #(5 5). false}
	) searchForOne asArray = #('data1 > data2') ifFalse: [self error: 'should have found it'].	



(MethodFinder new load: #((12 4 8) 2  (1 3 6) 2  (5 2 16) 8)
	) searchForOne asArray = #()     " '(data3 / data2) ' want to be able to leave out args"  
		ifFalse: [self error: 'should have found it'].	
(MethodFinder new load: #((0.0) 0.0  (1.5) 0.997495  (0.75) 0.681639)
	) searchForOne asArray = #('data1 sin') ifFalse: [self error: 'should have found it'].	
(MethodFinder new load: #((7 5) 2   (4 5) 4   (-9 4) 3)
	) searchForOne asArray = #('data1 \\ data2') ifFalse: [self error: 'should have found it'].	

(MethodFinder new load: #((7) 2   (4) 2 )
	) searchForOne asArray = #('^ 2')  ifFalse: [self error: 'should have found it'].	
(MethodFinder new load: {#(7). true.   #(4.1).  true.   #(1.5). false}
	) searchForOne asArray = #('data1 >= 4.1') ifFalse: [self error: 'should have found it'].	
(MethodFinder new load: #((35) 3   (17) 1   (5) 5)
	) searchForOne asArray = #('data1 \\ 8') ifFalse: [self error: 'should have found it'].	
(MethodFinder new load: #((36) 7   (50) 10 )
	) searchForOne asArray = #('data1 quo: 5' 'data1 // 5') ifFalse: [
		self error: 'should have found it'].	
(MethodFinder new load: #( ((2 3) 2) 8   ((2 3) 5) 17 )
	) searchForOne asArray = #('data1 polynomialEval: data2') ifFalse: [
		self error: 'should have found it'].	
(MethodFinder new load: #((2) 8   (5) 17 )
	) searchForOne asArray = #('#(2 3) polynomialEval: data1') ifFalse: [
		self error: 'should have found it'].	
! !
FinderUI initialize!
